/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.io.FileWriter;

public class Fconfig extends JDialog {
    public Fconfig(final JDialog parent) {
        super(parent, retail.app_name + " - Konfigurasi", true);
        setIconImage(retail.icon_app);
        setMinimumSize( new Dimension(500+100, 580+70) );

        JPanel panel = new JPanel();
	panel.setLayout(null);
        //panel.setBorder( BorderFactory.createCompoundBorder( BorderFactory.createLoweredBevelBorder() , BorderFactory.createRaisedBevelBorder() ) );
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(16, 16, 65, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Konfigurasi", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Trebuchet MS", Font.PLAIN, 14 )) ) );

        JLabel Ldatabase = new JLabel("Database", SwingConstants.RIGHT);
        Ldatabase.setBounds(60, 60, 130+30, 35);  panel.add(Ldatabase);
        final JTextField Tdatabase = new JTextField( retail.db.cfg.get("database"), 50);
        //Tdatabase.setBounds(100, 20, 260, 35);
        //Tdatabase.setBounds( Ldatabase.getX()+Ldatabase.getWidth(), Ldatabase.getY()+3, 260, 29 );
        Tdatabase.setBounds( 15 + panel.getComponent(0).getX() + panel.getComponent(0).getWidth(), panel.getComponent(0).getY()+3, 200, 29 );  panel.add(Tdatabase);

        JLabel Luser = new JLabel("User", SwingConstants.RIGHT);  panel.add(Luser);
        final JTextField Tuser = new JTextField( retail.db.cfg.get("user"), 50 );  panel.add(Tuser);

        JLabel Lpassword = new JLabel("Password", SwingConstants.RIGHT);  panel.add(Lpassword);
        final JPasswordField Ppassword = new JPasswordField(16); try{ Ppassword.setText( retail.db.decrypt( retail.db.cfg.get("password"), retail.db.encryptionKey )); } catch (Exception e) {};  panel.add(Ppassword);

        JLabel Lhost = new JLabel("Host", SwingConstants.RIGHT);  panel.add(Lhost);
        final JTextField Thost = new JTextField( retail.db.cfg.get("host"), 200);  panel.add(Thost);

        JLabel Lsocket = new JLabel("Socket", SwingConstants.RIGHT);  panel.add(Lsocket);
        final JTextField Tsocket = new JTextField( retail.db.cfg.get("socket"), 4);  panel.add(Tsocket);

        JLabel Ldbms = new JLabel("Jenis Database", SwingConstants.RIGHT);  panel.add(Ldbms);
        final JTextField Tdbms = new JTextField( retail.db.cfg.get("dbms"), 20);  panel.add(Tdbms);

        JLabel Luser_default = new JLabel("User Login Default", SwingConstants.RIGHT);  panel.add(Luser_default);
        final JTextField Tuser_default = new JTextField( retail.db.cfg.get("user_login_default"), 50 );  panel.add(Tuser_default);

        JLabel Lpassword_default = new JLabel("Password Login Default", SwingConstants.RIGHT);  panel.add(Lpassword_default);
        final JPasswordField Ppassword_default = new JPasswordField(16); try{ Ppassword_default.setText( retail.db.decrypt( retail.db.cfg.get("password_login_default"), retail.db.encryptionKey )); } catch (Exception e) {};  panel.add(Ppassword_default);

        JLabel Lbarcode_delay = new JLabel("Barcode Delay", SwingConstants.RIGHT);  panel.add(Lbarcode_delay);
        final JTextField Tbarcode_delay = new JTextField( retail.db.cfg.get("barcode_delay"), 3);  panel.add(Tbarcode_delay);

        JLabel Ldirektori_gambar = new JLabel("Direktori File Gambar", SwingConstants.RIGHT);  panel.add(Ldirektori_gambar);
        final JTextField Tdirektori_gambar = new JTextField( retail.db.cfg.get("direktori_gambar"), 300);  panel.add(Tdirektori_gambar);

        JLabel Lpembulatan = new JLabel("Pembulatan Rupiah", SwingConstants.RIGHT);  panel.add(Lpembulatan);
        final JTextField Tpembulatan = new JTextField( retail.db.cfg.get("pembulatan_rupiah"), 5);  panel.add(Tpembulatan);

        final JCheckBox CHppn_active  = new JCheckBox("PPN aktif secara default", retail.db.cfg.get("ppn_aktif_secara_default").equals("ya") );  panel.add(CHppn_active);
        final JCheckBox CHppn_visible = new JCheckBox("PPN ditampilkan", retail.db.cfg.get("ppn_ditampilkan").equals("ya"));  panel.add(CHppn_visible);

        final JBkeluar Bkeluar = new JBkeluar(this);

        final JButton Btest = new JButton("test koneksi");
        Btest.setAlignmentX( Bkeluar.getAlignmentX() );
        Btest.setIconTextGap( Bkeluar.getIconTextGap() );
        //Btest.setBounds(90, 200, 80, 35);//seaglass
        Btest.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-10-20, Bkeluar.getY(), Bkeluar.getWidth()+20, Bkeluar.getHeight() );//java default
        Btest.setMnemonic(KeyEvent.VK_T);

        final JButton Bsimpan = new JButton("simpan", retail.icon_save );
        Bsimpan.setAlignmentX( Btest.getAlignmentX() );
        Bsimpan.setIconTextGap( Btest.getIconTextGap() );
        //Bsimpan.setBounds(90, 200, 80, 35);//seaglass
        Bsimpan.setBounds( Btest.getX()-Btest.getWidth()-10, Btest.getY(), Btest.getWidth(), Btest.getHeight() );//java default
        Bsimpan.setMnemonic(KeyEvent.VK_S);  Bsimpan.addFocusListener(retail.onHover);
        Bsimpan.setEnabled(false);

        panel.add(Bsimpan);
        panel.add(Btest);
        panel.add(Bkeluar);

        getContentPane().add(panel);
        pack();
        //setSize(400, 280);  //harus sesudah pack():p
        setModalityType(Dialog.ModalityType.APPLICATION_MODAL); //DOCUMENT_MODAL
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE); //setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);     //setLocationRelativeTo(parent);

        //the events ....

        int ci=0;   String filter_pre;
        for(Component comp : panel.getComponents()) {
            if( comp instanceof JTextField || comp instanceof JPasswordField ) {
                JTextComponent tc = (JTextComponent)comp;
                AbstractDocument doc = (AbstractDocument) tc.getDocument();
                doc.putProperty("tombol_to_enable", new JButton[]{Bsimpan} );
                doc.setDocumentFilter(new PatternFilter( ".{0," + (int)((JTextField)comp).getColumns() + "}" ));
                if( comp==Tsocket || comp==Tpembulatan || comp==Tbarcode_delay ) filter_pre = "no-digit-separator\\d{0,";   //"\\d{1," >> dia lakukan validasi klo disetText("") atau setText(null) dari code
                else                                     filter_pre = ".{0,";    //\\w{0, >> A word character: [\p{Alpha}\p{gc=Mn}\p{gc=Me}\p{gc=Mc}\p{Digit}\p{gc=Pc}]
                doc.setDocumentFilter(new PatternFilter( filter_pre + (int)((JTextField)comp).getColumns() + "}" ));
                doc.addDocumentListener(retail.enable_on_change);
                tc.setMargin( new Insets( 0, 7, 0, 0 ) );
            }
            if( comp instanceof JLabel || comp instanceof JTextField || comp instanceof JPasswordField || comp instanceof JCheckBox ) {
                //if( ci>=2 ) comp.setBounds( new bound_top(panel,ci-2) );
                //ci++;
                ci = panel.getComponentZOrder(comp);
                if( ci>=2 ) comp.setBounds( panel.getComponent(ci-2).getX(), panel.getComponent(ci-2).getY()+40, panel.getComponent(ci-2).getWidth(), panel.getComponent(ci-2).getHeight() );
            }
        }

        CHppn_active.setVisible(retail.config_ppn_show);    CHppn_visible.setVisible(CHppn_active.isVisible());    //well, let them pay?    if( retail.hak_fitur???.indexOf("'blabla'") >= 0 ) {

        ItemListener CHenable_on_change = new ItemListener() { public void itemStateChanged(ItemEvent e) {
            if( e.getStateChange()!=ItemEvent.SELECTED && e.getStateChange()!=ItemEvent.DESELECTED ) return;
            if( e.getItemSelectable()==CHppn_active && e.getStateChange()==ItemEvent.SELECTED && !CHppn_visible.isSelected() ) CHppn_visible.setSelected(true);    //jika ppn aktif, paksain kudu tampil dong:)
            Bsimpan.setEnabled(true);
        }};
        CHppn_active.addItemListener(CHenable_on_change);
        CHppn_visible.addItemListener(CHenable_on_change);

        /*
        Tdbms.setFocusTraversalKeysEnabled( false ); //sayangnya ini jg mendisable tab dan arrow:D, jadi bukan hanya mendisable enter sebagai traversal key:p
        Tdbms.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if( Bsimpan.isEnabled() ) Bsimpan.doClick();
                else Tdatabase.requestFocus();
            }
        });
        */

        Bsimpan.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ((JButton)e.getSource()).setEnabled(false);
                //String to_write = ""; for (int i = 0; i < n; i++) to_write += panel.getComponent(n).getText() + "  :  "
                String newline = "\r\n"; //"\\n";  //kok unix version semua :p >> java.lang.Character newline = java.lang.Character.LINE_SEPARATOR;    //System.lineSeparator()
                try {
                    FileWriter writer = new FileWriter( retail.db.cfg.get("filename") ); // creates or overrides existing file
                    //byte[] cipher = retail.db.encrypt( (new String(Ppassword.getPassword())).getBytes(), "just rafikoi@yahoo.com");
                    //byte[] cipher = retail.db.encrypt( Ppassword.getPassword(), retail.db.encryptionKey );
                    //String pass = "";
                    //for (int i=0; i<cipher.length; i++) pass += new String(cipher[i]);
                    writer.append(
                             "# File Konfigurasi .... " + newline + "// Author : Rafik" + newline + newline + newline    //rafikoi@yahoo.com
                           + "Database : " + Tdatabase.getText().trim() + newline
                           + "User     : " + Tuser.getText().trim()     + newline
                           + "Password : \"" + retail.db.encrypt( Ppassword.getPassword(), retail.db.encryptionKey) + "\"" + newline
                           + "Host     : " + Thost.getText().trim()     + newline
                           + "Socket   : " + Tsocket.getText().trim()   + newline
                           + "DBMS     : " + Tdbms.getText().trim()     + newline
                           + newline
                           //+ "# Login Default"                          + newline
                           //+ "----------------------------------------" + newline
                           + "User Login Default     : " + Tuser_default.getText().trim()       + newline
                           + "Password Login Default : \"" + retail.db.encrypt( Ppassword_default.getPassword(), retail.db.encryptionKey) + "\"" + newline
                           //+ "----------------------------------------" + newline
                           + newline
                           + "Direktori Gambar     : " + Tdirektori_gambar.getText().trim()     + newline
                           + "Barcode Delay        : " + Tbarcode_delay.getText().trim().replace(retail.digit_separator, "") + newline
                           + "Pembulatan Rupiah    : " + Tpembulatan.getText().trim().replace(retail.digit_separator, "") + newline

                           + ( CHppn_active.isVisible() ?
                              newline
                              + "PPN aktif secara default : " + (CHppn_active.isSelected() ?"ya":"tidak")  + newline
                              + "PPN ditampilkan          : " + (CHppn_visible.isSelected()?"ya":"tidak")  + newline
                           : "" )
                    );
                    writer.flush();
                    writer.close();
                    retail.db.read_cfg(); //need to refresh the config vars!
                    ((JTextField)((Container)parent.getContentPane().getComponent(0)).getComponent(1)).setText( Tuser_default.getText().trim() );
                    ((JTextField)((Container)parent.getContentPane().getComponent(0)).getComponent(3)).setText( new String(Ppassword_default.getPassword()) );
                } catch (Exception ex) {
                    ((JButton)e.getSource()).setEnabled(true);
                    JOptionPane.showMessageDialog( Fconfig.this, "Penulisan File '" +retail.db.cfg.get("filename")+ "' Gagal!\n\n\n" + ex, "Penulisan File Gagal!", JOptionPane.ERROR_MESSAGE);
                //} finally { br.close();
                }
            }
        });

        Btest.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String err="";
                java.sql.Connection con = null;
                try {
                    con = java.sql.DriverManager.getConnection( "jdbc:" +Tdbms.getText().trim()+ "://" +Thost.getText().trim()+ ":" +Tsocket.getText().trim()+ "/" +Tdatabase.getText().trim()+ "" + "?user=" +Tuser.getText().trim()+ "&password=" + new String(Ppassword.getPassword()) );
                    JOptionPane.showMessageDialog( Fconfig.this, "Koneksi ke Database Berhasil!\n\n\n", "Koneksi Berhasil!", JOptionPane.ERROR_MESSAGE);  //belum tentu dia ubah:p >> Klik \"Simpan\" untuk menyimpan konfigurasi!\n
                    con.close();  con = null;
                } catch (Exception ex) {
                    if( ex.getMessage().indexOf("Access denied") >= 0) err = "Pastikan konfigurasi koneksi sudah benar!\n\n\n";
                    else                                               err = "Pastikan server database sudah dijalankan!\n\n\n";
                    JOptionPane.showMessageDialog( Fconfig.this, "Koneksi ke Database Gagal!\n" + err, "Koneksi Gagal!", JOptionPane.ERROR_MESSAGE);
                    try{ if( !con.isClosed() ) con.close(); } catch(Exception x) {};  //con.close();  con = null;
                }
            }
        });

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                if( !Bsimpan.isEnabled() ) { dispose(); return; }    //if( ((Window)SwingUtilities.windowForComponent((Component)e.getSource())).Bsimpan.isEnabled() ) {  //getAncestorNamed("Bsimpan", e.getSource())
                int resp = JOptionPane.showOptionDialog( retail.f, "\nPerubahan data ingin disimpan?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                if( resp==0 ) { //"YA"
                    Bsimpan.doClick();
                    if( !Bsimpan.isEnabled() ) dispose();
                } else if( resp==1 ) { //"TIDAK"
                    dispose();
                }
        }};

        Bkeluar.addActionListener(onClose);

        addWindowListener(new WindowAdapter() {  
            @Override
            public void windowClosing(WindowEvent e) {
                Bkeluar.doClick();
            }
            //@Override
            //public void windowClosed(WindowEvent e) {} //ini jadi dua kali dipanggil krn ini akan dipanggil lagi oleh parent!!!
        });

        retail.removeTitleButtons(this, onClose);
        retail.addUpDownToTraversalKeys(this);
        retail.addEnterToTraversalKeys(this);
        //retail.addLeftRightToTraversalKeys(this);

//Bsimpan.doClick();
        setVisible(true);
    }
}