/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import javax.swing.table.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class Fedit_grup_modul extends JDialog {
    //must be public to let retail.click_button() ...
    public JButton Bhapus;    public JBprint_auto Bprint;  public JBexport_xls Bexport_xls;
    private db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    public JTable table;    public JMenuItem menu_tambah = null;
    int last_selected_row = -13;    Boolean is_saved=false;
    public Fedit_grup_modul(final JFrame parent) {
        super(parent, retail.app_name + " - Edit Hak Akses Modul" + "   ::   Petugas: " + retail.nama, true);
        final String modul = "Edit Hak Akses Modul";
        final int row_height = 32;
        setIconImage(retail.icon_app);

        final JPanel panel = new JPanel();
	panel.setLayout(null);

        table = new JTable(db);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        table.setSurrendersFocusOnKeystroke(true);
        TableRowSorter<TableModel> sorter = new TableRowSorter<TableModel>(db);
        table.setRowSorter(sorter);
        table.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE); //Paling tidak utk memaksa update terjadi saat filtering table:p >> Note that this solution will cause the table to stop editing when any component get focus. I believe this logic is limited to components on the current window, but must admit I havent tested it. This solution will also not work when you click on the window buttons (ie, minimize or close).

        db.column_model = table.getColumnModel();
        JCdb cb_grup  = new JCdb("user_grup");
        JCdb cb_modul = new JCdb("modul");
        db.col_editor = new JComponent[] { cb_grup, cb_modul };
        db.col_width  = new int[]        {     180,      350 };
        String sql =               "SELECT grup_id, modul_id   FROM user_grup_modul ORDER BY 1,2";
        db.exec( "DELETE FROM user_grup_modul WHERE grup_id = -1 OR modul_id = -1" , null, true );    //ini akibat bingungnya gue:) ... klo dipaksa defaultnya adalah item ke-0, user bisa ngalami locking akibat error duplikat mulu. Kebingungan gue bisa dilihat di db_connecton.java:)
        db.exec( sql, null, false, true );
        if( !db.err_msg.equals("") ) { error("Pembacaan Data Gagal");   return; }

        //set height
        table.setRowHeight(row_height);
        JTableHeader header = new JTableHeader( db.column_model ) { @Override public Dimension getPreferredSize() {
                Dimension d = super.getPreferredSize();
                d.height = row_height;
                return d;
        }};
        table.setTableHeader(header);

        JScrollPane scrollpane = new JScrollPane(table);

        getContentPane().add(panel);        
        panel.add(scrollpane);
        pack();
        setBounds(GraphicsEnvironment.getLocalGraphicsEnvironment().getMaximumWindowBounds()); // setAlwaysOnTop(true);   Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); //setSize(800,800); //setExtendedState( getExtendedState()|JFrame.MAXIMIZED_BOTH );

        scrollpane.setBounds( 50, 55, parent.getWidth()-2*51, parent.getHeight()-2*55 -60);    //scrollpane.setBounds(50, 55, 900, 538);
        scrollpane.setBorder( BorderFactory.createRaisedBevelBorder() );
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(16, 16, 60, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "F2 - Edit Hak Akses Modul" ) ) );

        final JBkeluar Bkeluar = new JBkeluar(this);
        panel.add(Bkeluar);

        Bprint = new JBprint_auto(table);
        Bprint.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-20, Bkeluar.getY(), Bkeluar.getWidth(), Bkeluar.getHeight() );    //Bprint.setBounds( scrollpane.getX() + scrollpane.getWidth() + 20, scrollpane.getY() + scrollpane.getHeight() - Bkeluar.getHeight(), Bkeluar.getWidth(), Bkeluar.getHeight() );
        panel.add(Bprint);

        Bexport_xls = new JBexport_xls(this);    //ini harus sesudah init table dan Bsimpan (jika ada) krn constructor JBexport_xls ngebaca component2 tsb.
        Bexport_xls.setBounds( Bprint.getX()-Bprint.getWidth()-5, Bprint.getY(), Bprint.getWidth(), Bprint.getHeight() );
        panel.add(Bexport_xls);

        final JPopupMenu popup = new JPopupMenu();
        panel.add(popup);

        //JMenuItem menu_tambah = null;
        if( retail.hak_akses.indexOf("'" +modul.replace("Edit Data","Tambah")+ "'") >= 0 ) {
            menu_tambah = new JMenuItem("F11 - Tambah Baris Baru", retail.icon_insert);
            menu_tambah.setMnemonic(KeyEvent.VK_T);
            popup.add(menu_tambah);
            menu_tambah.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                    retail.add_row(table);
            }});
        }


        final JMenuItem menu_hapus = new JMenuItem("F12 - Hapus Baris ini", retail.icon_delete);
        menu_hapus.setMnemonic(KeyEvent.VK_H);
        menu_hapus.setEnabled(false);
        popup.add(menu_hapus);

        Bhapus = new JButton("F12 - hapus baris", retail.icon_delete);
        Bhapus.setAlignmentX( Bkeluar.getAlignmentX() );
        Bhapus.setIconTextGap( Bkeluar.getIconTextGap() );
        Bhapus.setBounds( Bexport_xls.getX()-Bprint.getWidth()-15-30, Bprint.getY(), Bprint.getWidth()+30, Bprint.getHeight() );//java default
        Bhapus.setMnemonic('H');  Bhapus.addFocusListener(retail.onHover);
        Bhapus.setEnabled(false);
        panel.add(Bhapus);
        ActionListener act_hapus = new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                int row = table.getSelectedRow();
                if( row<0 ) return;
                table.requestFocus();
                if( 0 != JOptionPane.showOptionDialog( Fedit_grup_modul.this, "\nData baris ke-" +(row+1)+ " ingin dihapus?\n\n\n\n", "Konfirmasi", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions2, null) )   return;
                if( table.isEditing() ) table.getCellEditor().cancelCellEditing();    //jika tidak di sini, post editing terjadi setelah didelete ... lah?! aneh :)
                db.removeRow( table.convertRowIndexToModel(row) );
                if( row<table.getRowCount() ) table.setRowSelectionInterval(row, row);
                else if( table.getRowCount()>0 ) table.setRowSelectionInterval(row-1, row-1);   //ini harus sesudah diremove:p  else if( table.getRowCount()>0 ) table.setRowSelectionInterval(row+1, row+1);
                else { Bhapus.setEnabled(false);    menu_hapus.setEnabled(false); }
        }};
        Bhapus.addActionListener(act_hapus);
        menu_hapus.addActionListener(act_hapus);

        table.setSelectionMode(0);  //SINGLE_SELECTION
        table.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                if( e.getValueIsAdjusting() ) return;
                //ternyata ga kerja:p >> if( table.isEditing() )
                is_saved=true;
                int row = table.getSelectedRow();    //Fedit_grup.this.setTitle( Fedit_grup.this.getTitle() + "last=" + last_selected_row);
                if( row<0 ) {    //if( row<0 || last_selected_row==row || table.getRowCount()!=db.getRowCount() ) return;    //supaya ga diulang2 mulu   //juga exit if filtered
                    Bhapus.setEnabled(false);    menu_hapus.setEnabled(false);
                    return;
                }
                Bhapus.setEnabled(true);    menu_hapus.setEnabled(true);    //jgn taruh di bawah krn ada kasus di mana user select lalu filtering sehingga table.getSelectedRow()==-1 trus unfiltering ... lah, tombol ini ga terenable:)
                row = table.convertRowIndexToModel( row );  //ini berat sehingga lambat saat filter!!
                if( last_selected_row==row ) return;    //supaya ga diulang2 mulu
                if( last_selected_row>=0 && last_selected_row<db.getRowCount() ) {    //if( last_selected_row>=0 && last_selected_row<table.getRowCount() ) {    //user batal nginsert row
                    String left_val = db.getValueAt(last_selected_row, 0).toString();    //table.convertRowIndexToModel(last_selected_row);
                    String right_val = db.getValueAt(last_selected_row, 1).toString();    //lah biar adil kok .... boleh muncul aja jika salah satu kosong ... krn tetap bisa terjadi error duplikasi data di db :p
                    if( left_val.equals("0") || left_val.equals("") ) if( right_val.equals("0") || right_val.equals("") ) db.removeRow( last_selected_row );  //user batal nginsert row   //retail.db.rows.removeElementAt(last_row);
                }                 
                last_selected_row = row;
            }
        });
        table.addMouseListener( new MouseListener() {
            public void mousePressed(MouseEvent e) {
                if( !( e.getComponent() instanceof JTable && (e.getModifiers() & InputEvent.BUTTON3_MASK ) == InputEvent.BUTTON3_MASK ) ) return;
                JTable table = (JTable)e.getComponent();
                int row = table.rowAtPoint(e.getPoint());
                if( table.isEditing() ) table.getCellEditor().stopCellEditing();
                table.setRowSelectionInterval(row, row);
                popup.show(table, e.getX(), e.getY());
            }
            public void mouseClicked(MouseEvent e) {}    public void mouseEntered(MouseEvent e) {}    public void mouseExited(MouseEvent e) {}    public void mouseReleased(MouseEvent e) {}
        });

        retail.Brefresh.setBounds( Bhapus.getX()-Bexport_xls.getWidth()-15, Bexport_xls.getY(), Bexport_xls.getWidth(), Bexport_xls.getHeight() );
        panel.add(retail.Brefresh);

        JLabel Lcari = new JLabel("F1 - Cari", retail.icon_search, JLabel.LEFT);    Lcari.setDisplayedMnemonic('C');    Lcari.setFont( new Font( "Dialog", Font.BOLD, 12 ));    //"Cari   ( F1 )"
        Lcari.setBounds( 23, retail.Brefresh.getY(), 53+36, 35);  Lcari.setIconTextGap( Bkeluar.getIconTextGap()-2 );  panel.add(Lcari);
        final JTextField Tcari = new JTextField();    Tcari.setMargin( new Insets( 0, 7, 0, 0 ) );
        Tcari.setBounds( Lcari.getX()+Lcari.getWidth(), Lcari.getY(), retail.Brefresh.getX()-Lcari.getX()-Lcari.getWidth()-10, Lcari.getHeight() );  panel.add(Tcari);
        Tcari.requestFocus();
        Lcari.setLabelFor(Tcari);
        retail.add_search_on_change( Tcari, sorter, menu_tambah);

        setModalityType(Dialog.ModalityType.APPLICATION_MODAL); //DOCUMENT_MODAL
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE); //setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setResizable(false);

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                close();
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  
            @Override public void windowClosing(WindowEvent e) {
                if( table.isEditing() ) table.getCellEditor().stopCellEditing();    //post update jika icon close diklik atau ALT-F4 :)  //ga mo cerewet ah:)) >> if( !db.err_msg.equals("") ) { error("Update Data Gagal");   return; }
                Bkeluar.doClick();
            }
        });

        retail.removeTitleButtons(this, onClose);
        setVisible(true);
    }

    void close() {
        try { db.rs.close(); } catch (Exception e) {}
        //agak ribet klo mo restart otomatis :p >> http://stackoverflow.com/questions/4159802/how-can-i-restart-a-java-application
        if( is_saved ) JOptionPane.showMessageDialog( this, "\nJika Saudara melakukan perubahan hak akses, mohon tutup kemudian jalankan kembali aplikasi ini untuk mengaktifkannya!\n\n\n\n\n", "Mohon Jalankan Kembali Aplikasi", JOptionPane.ERROR_MESSAGE);
        db.close();  /*db.rows=null;*/
        table.setRowSorter(null);  //sorter=null;  //aneh aja ... tanpa ini, jika row diubah urutannya trus didelete, lalu ditutup-buka lagi, terjadi error saat fireTableRowsInserted(getRowCount()-1, getRowCount()-1);
        dispose();
    }
    void error(String title) {
            JOptionPane.showMessageDialog( this, db.err_msg, title, JOptionPane.ERROR_MESSAGE);
            close();
    }
}