/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import javax.swing.*;
public class Fedit_kas extends Fedit {
    public Fedit_kas(final Window parent) {
        super(parent, "Edit Kas Masuk/Keluar", "Edit Data Kas Masuk/Keluar");
        setVisible(true);
    }
    @Override void build_sql() {
        db = new db_connection() {    //indahnya inherit :)
            @Override public void setValueAt(Object val, int row_idx, int col_idx) {
                if( to_str( col_idx, getValueAt(row_idx, col_idx).toString().trim() ).equals( to_str(col_idx, val.toString().trim()) ) ) return;
                if( col_idx==1 || col_idx==2 ) {    //benahi negative sign :p
                    if( col_idx==1 ) {    //jika masuk_keluar diedit, ....
                        int masuk_keluar = Integer.valueOf( to_db(1, val) );
                        int amount=getIntAt(row_idx, 2);
                        if( masuk_keluar>0 && amount<0 || masuk_keluar<0 && amount>0 ) super.setValueAt( -1*amount, row_idx, 2 );
                    } else {    //jika amount diedit, ....
                        int masuk_keluar = Integer.valueOf( to_db(1, getValueAt(row_idx, 1)) );
                        int amount=Integer.valueOf(val.toString());
                        if( masuk_keluar>0 && amount<0 || masuk_keluar<0 && amount>0 ) super.setValueAt( ((JCdb)col_editor[1]).my_string_of_key(-1* masuk_keluar), row_idx, 1 );
                    }
                }
                super.setValueAt(val, row_idx, col_idx);
            }
        };
        //JComboBox Cjenis = new JComboBox( new String[] {"Kas Masuk","Kas Keluar"} );
        JCdb Cjenis      = new JCdb("def_kas_masuk_keluar");
        JCdb Cuser       = new JCdb("SELECT id, username FROM user ORDER BY id");
        db.col_editor    = new JComponent[] { null,       Cjenis,   null,       null,    null,   Cuser,     null  };
        db.col_width     = new int[]        {    0,          100,    100,        350,     150,     100,       80  };
        sql =                           "SELECT id, masuk_keluar, amount, keterangan, tanggal, user_id, terminal   FROM kas ORDER BY 1";
    }
}