/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import org.jdesktop.swingx.JXDatePicker;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

public class Fhapus_penjualan extends Ftambah {
    JXDatePicker Dstop;    Date Dstop_date;
    public Fhapus_penjualan(final Window parent) {
        this(parent,"Hapus Data Penjualan");
    }
    public Fhapus_penjualan(final Window parent, String title) {
        super(parent, title);
        modul = title;    //"Hapus Data Penjualan";

        JLabel Lstop = new JLabel(modul+" sebelum", JLabel.RIGHT);
        Lstop.setBounds(90, 90, 70+100+100, 35);  panel.add(Lstop);

        final Calendar cal = Calendar.getInstance();
        cal.add(Calendar.MONTH, -1);
        Date sebln_lalu = cal.getTime();
        Dstop = new JXDatePicker(sebln_lalu);  Dstop.setFont(new Font( "Book Antigua", Font.PLAIN, 12 ));   Dstop.getEditor().setMargin( new Insets( 0, 7, 0, 0 ) );
        Dstop.setFormats(new SimpleDateFormat("dd-MM-yyyy"));
        Dstop.setLinkDay(new Date(), "Hari ini: {0, date, EEEE, dd-MM-yyyy}");
        Dstop.setBounds( 15-9 + panel.getComponent(3).getX() + panel.getComponent(3).getWidth(), panel.getComponent(3).getY()+3, 150, 29 );
        panel.add(Dstop);

        Lstop.setLabelFor(Dstop);

        //mandatory.add(Dstop);
        //align_comps();
        Lstop.setDisplayedMnemonic( 'P' );
        //cal.add(Calendar.YEAR, -100);
        //final Date seratus_thn_lalu = cal.getTime();
        Dstop.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            if( !Dstop.COMMIT_KEY.equals(e.getActionCommand()) ) return;
            Bsimpan.setEnabled(true);    Bkosongkan.setEnabled(true);
	}});
        //ternyata editor selalu diclear oleh DatePicker >> Dstop.getEditor().setText( new SimpleDateFormat("dd-MM-yyyy").format( sebln_lalu ) );
        Dstop.getEditor().getDocument().addDocumentListener(new DocumentListener() {
            public void changedUpdate(DocumentEvent e) {
/*
                Date Dstop_temp = Dstop.getDate();
                if( Dstop_temp==Dstop_date ) return;
*/
                /* klo user pencet keluar, tombol simpan tetap enable:p
                if( Dstop_date==null ) {
                    Dstop_date = seratus_thn_lalu;
                    return;
                } else if( Dstop_date==seratus_thn_lalu ) {    //then user need to enter to accept this first initial value :p
                    cal.add(Calendar.YEAR, -100);
                    Dstop_date = cal.getTime();
                    return;
                }
                */
/*
                Dstop_date = Dstop_temp;
                Bsimpan.setEnabled(true);    Bkosongkan.setEnabled(true);    //Bkosongkan harus enable, otherwise, bikin tombol simpan tetap enable setelah simpan
*/
            }
            public void removeUpdate(DocumentEvent e) {
                if( !Dstop.getEditor().getText().isEmpty() )    {   Bsimpan.setEnabled(true);    Bkosongkan.setEnabled(true);  }    //if( !Dstop.getEditor().getText().equals( new SimpleDateFormat("dd-MM-yyyy").format( Dstop.getDate())) )    //Bkosongkan harus enable, otherwise, bikin tombol simpan tetap enable setelah simpan
                //changedUpdate(e);
            }
            public void insertUpdate(DocumentEvent e) { changedUpdate(e); }
        });
        ////ga bisa >> biar tombol enable di saat user masuk pertama:) >> Dstop_date=null;
        //Dstop_date=Dstop.getDate();
        Bkosongkan.setVisible(false);
        setVisible(true);
        //anyway, tombolnya sebaiknya bukan simpan tapi hapus atau execute:)
    }
    @Override Boolean build_sql() {
        String date = "'" +new SimpleDateFormat("yyyy-MM-dd").format( Dstop.getDate())+ "'" ;
        sql = " INSERT INTO jual_hapus SELECT * FROM jual WHERE faktur_id IN (SELECT id FROM jual_faktur WHERE tgl_faktur < " +date+ ")  ;\n"
            + " DELETE FROM jual WHERE faktur_id IN (SELECT id FROM jual_faktur WHERE tgl_faktur < " +date+ ")  ;\n"
            + " INSERT INTO jual_backup_hapus SELECT * FROM jual_backup WHERE faktur_backup_id IN (SELECT id FROM jual_faktur_backup WHERE tgl_faktur < " +date+ ")  ;\n"
            + " DELETE FROM jual_backup WHERE faktur_backup_id IN (SELECT id FROM jual_faktur_backup WHERE tgl_faktur < " +date+ ")  ;\n"
            + " INSERT INTO jual_faktur_backup_hapus SELECT * FROM jual_faktur_backup WHERE tgl_faktur < " +date+ "  ;\n"
            + " DELETE FROM jual_faktur_backup WHERE tgl_faktur < " +date+ "  ;\n"
            + " INSERT INTO jual_faktur_hapus SELECT * FROM jual_faktur WHERE tgl_faktur < " +date+ "  ;\n"
            + " DELETE FROM jual_faktur WHERE tgl_faktur < " +date+ "  ;\n"
            + " ALTER TABLE jual_faktur AUTO_INCREMENT = 1  ;\n" ;    //nice way to reset AUTO_INCREMENT :D
        //this.params=null;
        return true;
    }
}