/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.AbstractDocument;
import javax.imageio.ImageIO;
import java.io.File;

public class Flogin extends JDialog {
    //private static Fconfig fconfig = null;
    public Flogin(final JFrame parent) {
        super(parent, retail.app_name + " - Login", true);  //call parent class constructor
        setIconImage(new ImageIcon("img/Lock2.png").getImage()); //document-encrypt.png  //Lock-red.png
        setMinimumSize( new Dimension(400, 280) );

        JPanel panel = new JPanel(); //JPanel panel = new JPanel(new GridBagLayout());
	panel.setLayout(null);
        //panel.setBorder( BorderFactory.createCompoundBorder( BorderFactory.createLoweredBevelBorder() , BorderFactory.createRaisedBevelBorder() ) );
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(2, 2, 2, 2) , BorderFactory.createRaisedBevelBorder() ) ); //createEtchedBorder

        JLabel Luser = new JLabel("Nama User");
        Luser.setBounds(20, 20, 80, 35);    Luser.setDisplayedMnemonic('N');
        panel.add(Luser);

        final JTextField Tuser = new JTextField(retail.db.cfg.get("user_login_default"), 20);
        //Tuser.setBounds(100, 20, 260, 35);
        Tuser.setBounds( Luser.getX()+Luser.getWidth(), Luser.getY()+3, 260, 29 );
        Luser.setLabelFor(Tuser);
        panel.add(Tuser);

        JLabel Lpassword = new JLabel("Password");    Lpassword.setDisplayedMnemonic('P');
        Lpassword.setBounds( Luser.getX(), Luser.getY()+40, Luser.getWidth(), Luser.getHeight() );
        panel.add(Lpassword);

        final JPasswordField Ppassword = new JPasswordField("", 20);
        try{ Ppassword.setText( retail.db.decrypt( retail.db.cfg.get("password_login_default"), retail.db.encryptionKey )); } catch (Exception e) {};
        //Ppassword.setBounds(100, 60, 260, 35);
        Ppassword.setBounds( Tuser.getX(), Tuser.getY()+40, Tuser.getWidth(), Tuser.getHeight() );
        Lpassword.setLabelFor(Ppassword);
        panel.add(Ppassword);

        final JBkeluar Bkeluar = new JBkeluar(this);

        final JButton Blogin = new JButton("login", new ImageIcon("img/document-decrypt.png") ); //key_12-20110811143535-00002.png  //  stock_lock.png  key_5-20110811143437-00011.png
        Blogin.setAlignmentX( Bkeluar.getAlignmentX() );
        Blogin.setIconTextGap( Bkeluar.getIconTextGap() );
        //Blogin.setBounds(90, 200, 80, 35);//seaglass
        Blogin.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-10, Bkeluar.getY(), Bkeluar.getWidth(), Bkeluar.getHeight() );//java default
        Blogin.setMnemonic(KeyEvent.VK_L);  Blogin.addFocusListener(retail.onHover);
        Blogin.setToolTipText("Silahkan klik untuk login!");

        panel.add(Blogin);
        panel.add(Bkeluar);

        final JButton Bdatabase = new JButton("Setting", new ImageIcon("img/run-build.png"));    //system-run.png
        Bdatabase.setAlignmentX( Bkeluar.getAlignmentX() );  Bdatabase.setIconTextGap( Bkeluar.getIconTextGap()-2 );
        Bdatabase.setBounds( Tuser.getX()+Tuser.getWidth()-80-10, Ppassword.getY()+Ppassword.getHeight()+5, 80+10, 27 );
        Bdatabase.setMnemonic(KeyEvent.VK_S);  Bdatabase.addFocusListener(retail.onHover);
        Bdatabase.setToolTipText("Silahkan klik untuk mengubah setting database dan lain-lain!");
        panel.add(Bdatabase);

        JLabel bg = new JLabel();
        //JLabel bg = new JLabel(new ImageIcon("img/bg.jpg"));
        try{ bg.setIcon( new ImageIcon( ImageIO.read( new File("img/bg.jpg") ) ));    } catch (Exception e) {}    //If the image is external to the application (somewhere on the file system), you can use ImageIO.read(new File("/path/to/image")). However, if the the image is embedded within your application (stored within the Jar for example), you will need to use something more like ImageIO.read(getClass().getResource("/path/to/image")) instead...
        //bg.setBounds(6, 6, 286, 240); //seaglass
        bg.setBounds(3, 3, getWidth()-3-2*5, getHeight()-2*20); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default
	panel.add(bg);

        getContentPane().add(panel);
        pack();
        //setSize(400, 280);  //harus sesudah pack():p
        setModalityType(Dialog.ModalityType.APPLICATION_MODAL); //DOCUMENT_MODAL
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);     //setLocationRelativeTo(parent);

        //the events ....
        Blogin.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            //biar ajalah:) >> if( retail.empty( new javax.swing.text.JTextComponent[]{ Tuser } )) return;
            String auth_msg = authenticate( Tuser.getText(), new String(Ppassword.getPassword()) );
            if( auth_msg == "" ) {
                retail.play_wav("sound/plunger.wav");  //yippee.wav   Door Unlock-SoundBible.com-1558114225.wav //
                setVisible(false);    //supaya ga saru:)
                JLabel Lnama = new JLabel(retail.nama, JLabel.CENTER);
                Lnama.setFont( new Font("Trebuchet MS", Font.PLAIN, 38) );    //Lnama.setFont( Lnama.getFont().deriveFont(24f) );    //label.setFont( new Font("Trebuchet MS", Font.PLAIN, 36) );    //new Font(Font.DIALOG, Font.BOLD, 48);    //"Serif", Font.PLAIN, 24    //new Font("Trebuchet MS", Font.PLAIN, 12 ))
                //Lnama.setForeground( Color.MAGENTA );
                retail.init_colors();
                javax.swing.Timer timer = new javax.swing.Timer( retail.DELAY, new blink(Lnama));    timer.setInitialDelay(0);  timer.setCoalesce(true);  timer.start();
                //ga ngaruh .... Lnama.setSize( new Dimension(100, 365) );    //Lnama.setBounds(0, 100, 365, 100);

                int jam = Calendar.getInstance().get(Calendar.HOUR_OF_DAY);
                String paruh;
                     if( jam>=0  && jam<9   ) paruh = "Pagi";
                else if( jam>=9  && jam<15  ) paruh = "Siang";
                else if( jam>=15 && jam<18  ) paruh = "Sore";
                else                          paruh = "Malam";
                Object[] msg_nama = { "\nSelamat " + paruh + " ...                                                                                       \n\n\n",Lnama,"\n\n\n\n\n\n\n","\n" }; //ga iso ... label.setSize( new Dimension(600, 650) );
                JOptionPane.showMessageDialog(Flogin.this, msg_nama, "Selamat " + paruh, JOptionPane.INFORMATION_MESSAGE);    //JOptionPane.showMessageDialog(Flogin.this, "\nSelamat Datang \"" + retail.nama + "\"!\n\n\n\n", "Selamat Datang", JOptionPane.INFORMATION_MESSAGE);
                timer.stop();
                //parent.setVisible(true);
                dispose();
            } else {
                retail.play_wav("sound/password_salah.wav");  //twang.wav   sfboing1.wav  glass.wav  pig.wav  doh.wav horse.wav   sheep.wav cat.wav
                JOptionPane.showMessageDialog(Flogin.this, "\n" + auth_msg + "\n\n\n\n", "Login Gagal", JOptionPane.ERROR_MESSAGE);
            }
        }});

        Bdatabase.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                //open Fconfig to save db config
                new Fconfig( (JDialog)((JComponent)e.getSource()).getParent().getParent().getParent().getParent().getParent() );   //fconfig = new retail.Fconfig(this);
                //not wise krn user bahkan ga nyimpen :) Tuser.setText(retail.db.cfg.get("user_login_default"));
        }});

/* leave it to eventdispatcher:)
        Tuser.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                Ppassword.requestFocus();
        }});
        Ppassword.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                Blogin.doClick();
        }});
*/

        ((AbstractDocument)Tuser.getDocument()).setDocumentFilter(new PatternFilter( ".{0,10}" ));  //batasi panjang karakter
        ((AbstractDocument)Ppassword.getDocument()).setDocumentFilter(new PatternFilter( ".{0,16}" ));

        Tuser.selectAll();
        Ppassword.selectAll();

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                dispose();
                //not wise krn tetap dua kali nutup kedua form:) So, just rely on retail.nama below >> if( parent.isVisible() ) parent.dispose(); //parent.dispose() akan nutup form child ini jg sehingga kembali akan manggil WindowsClosed :)
        }};

        Bkeluar.addActionListener(onClose);

        addWindowListener(new WindowAdapter() {
            //ga bs >> @Override public void windowActivated(WindowEvent e) {
            //    if( retail.db==null ) retail.db = new db_connection();
            //}
            @Override public void windowClosing(WindowEvent e)  {
                Bkeluar.doClick();
            }
            //@Override
            //public void windowClosed(WindowEvent e)  {}
        });

        retail.removeTitleButtons(this, onClose);
        retail.addUpDownToTraversalKeys(this);
        retail.addEnterToTraversalKeys(this);
        //retail.addLeftRightToTraversalKeys(this);

        CustomizedTabOrder tab_order = new CustomizedTabOrder( getFocusTraversalPolicy() );
        tab_order.bind( Ppassword, Blogin );
        tab_order.bind( Bkeluar, Bdatabase );
        tab_order.setLastComponent( Bdatabase );
        setFocusTraversalPolicy(tab_order);

//Blogin.doClick();
        setVisible(true);
    }

    private String authenticate( String username, String password ) {
        db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
        int warning_limit = 1000;
        String sql = " SELECT id, nama "
                   + "      , ( SELECT GROUP_CONCAT( QUOTE(m.name) ) "
                   + "          FROM user_grup_modul gm "
                   + "          INNER JOIN modul m ON gm.modul_id=m.id "
                   + "          INNER JOIN user_grup g ON gm.grup_id=g.id "
                   + "          WHERE g.id=user.grup_id "
                   + "        ) AS hak_akses "
                   + "      , @nama_perusahaan := ( SELECT value FROM setting WHERE code LIKE '%nama perusahaan%' ) "
                   + "      , ( SELECT GROUP_CONCAT( CONCAT_WS(':',code,value) ) "
                   + "          FROM setting "
                   + "          WHERE valid=MD5(CONCAT_WS(code,@nama_perusahaan,id,code,value)) "
                   + "        ) AS setting "

                   + "      , LEAST( "
                   + "          ( "
                   + "            SELECT "
                   + "              IF(LCASE(COLUMN_TYPE) LIKE '%unsigned%',2,1) * "
                   + "              CASE DATA_TYPE "
                   + "                WHEN 'tinyint' THEN 127 "
                   + "                WHEN 'smallint' THEN 32767 "
                   + "                WHEN 'mediumint' THEN 8388607 "
                   + "                WHEN 'int' THEN 2147483647 "
                   + "                ELSE 9223372036854775807 "
                   + "              END "
                   + "            - "
                   + "            IFNULL((SELECT MAX(id) FROM jual_faktur),0) "    //-13+32767*2-1000(warning_limit)
                   + "            FROM information_schema.columns WHERE TABLE_SCHEMA='" +db.cfg.get("database") + "' AND TABLE_NAME='jual_faktur' AND COLUMN_NAME='id' LIMIT 1 "
                   + "          ) "
                   + "          , "
                   + "          " +warning_limit+ "+1 "
                   + "        ) AS penjualan_left "

                   + " FROM user "
                   + " WHERE username='" +retail.escape(username.trim())+ "'"
                   + " AND password=MD5('" +retail.escape(password)+ "')"
                   ;
        db.exec(sql);
        if( db.err_msg != "" ) return db.err_msg;
        if( db.rs.size() <= 0 ) { //return "Maaf, User atau Password tidak cocok!";   //"Maaf, Nama User \"" +username+ "\" tidak ditemukan!";
            db.exec( "SELECT 1 FROM user WHERE username='" +retail.escape(username.trim())+ "'" );  //check if even the username exist:)
            if( db.err_msg  != "" ) return db.err_msg;
            if( db.rs.size() <= 0 ) return "Maaf, User \"" +username+ "\" tidak ditemukan!";
            else                    return "Maaf, Password tidak cocok!";
        }
        try {
            db.rs.next();
            retail.user_id   = db.rs.getInt(1) ;
            retail.nama      = db.rs.getString(2) ;
            retail.hak_akses = db.rs.getString(3) ;
            if( db.rs.getString(5) != null )
                for( String sets: db.rs.getString(5).split(",")) {
                    String[] set = sets.split(":");
                    retail.setting.put( set[0].trim(), set.length>1 ? set[1].trim() : "" );   //jgn krn nama perusahaan ada di sindang >> .toLowerCase()        switch(var) //(only) In the JDK 7 release, you can use a String object in the expression of a switch statement:
                }
            int pos_space   = retail.app_name.indexOf("  ");    //di bawah jangan diisi dua titikdua atau pipeline atau strip atau double space!!!
            retail.app_name = retail.app_name.substring(0,pos_space) + " " + retail.convert_null(retail.setting.get("Nama Perusahaan")) + retail.app_name.substring(pos_space+1, retail.app_name.length());
            retail.f.setTitle(retail.app_name);
            int penjualan_left = db.rs.getInt(6);
            if( penjualan_left <= warning_limit ) JOptionPane.showMessageDialog(Flogin.this, "\nDatabase penuh. Hanya tersisa " + penjualan_left + " transaksi penjualan lagi.\nMohon segera hapus seluruh data transaksi penjualan melalui Menu \"Transaksi -> Hapus -> Hapus Data Penjualan\"\nmenggunakan user \"admin\" atau user yang memiliki hak akses!\n\n\n\n", "Database Penuh", JOptionPane.ERROR_MESSAGE);
            db.rs.close();
        } catch (Exception e) {
            return "Maaf, data user gagal dibaca!\n(" + e + ")";
        }
        return "";
    }
}