/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;

public class Ftambah extends JDialog {
    public JButton Bsimpan;    public JButton Bkosongkan;
    protected db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    protected String modul;
    protected JPanel panel;
    protected String sql;
    protected String[] params;
    ArrayList<JTextComponent> mandatory = new ArrayList<JTextComponent>();
    ArrayList<JTextComponent> comp_number = new ArrayList<JTextComponent>();
    public Ftambah(final Window parent, String title) {    //JFrame parent
        super(parent, retail.app_name + " - " + title + "   ::   Petugas: " + retail.nama, Dialog.ModalityType.APPLICATION_MODAL);
        String err_msg = "";
        setIconImage(retail.icon_app);
        setMinimumSize( new Dimension(850, 650) );

        panel = new JPanel();
	panel.setLayout(null);
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(26, 16, 65, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), title ) ) );

/*
        JLabel Lname = new JLabel("Grup User", JLabel.LEFT);
        Lname.setBounds(70, 80, 65, 35);  panel.add(Lname);
        final JTextField Tname = new JTextField();  Tname.setMinimumSize( new Dimension(20, 1) );
        Tname.setBounds( 15 + panel.getComponent(0).getX() + panel.getComponent(0).getWidth(), panel.getComponent(0).getY()+3, 200, 29 );  panel.add(Tname);

        JLabel Lketerangan = new JLabel("Keterangan", JLabel.LEFT);  panel.add(Lketerangan);
        final JTextField Tketerangan = new JTextField();  Tketerangan.setMinimumSize( new Dimension(255, 1) );  panel.add(Tketerangan);
*/

        final JBkeluar Bkeluar = new JBkeluar(this);

        Bkosongkan = new JButton("F5 - kosongkan", retail.icon_reset);
        Bkosongkan.setAlignmentX( Bkeluar.getAlignmentX() );
        Bkosongkan.setIconTextGap( Bkeluar.getIconTextGap() );
        Bkosongkan.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-10-30, Bkeluar.getY(), Bkeluar.getWidth()+30, Bkeluar.getHeight() );//java default
        Bkosongkan.setMnemonic('O');  Bkosongkan.addFocusListener(retail.onHover);
        Bkosongkan.setEnabled(false);

        Bsimpan = new JButton("F10 - simpan", retail.icon_save );
        Bsimpan.setAlignmentX( Bkosongkan.getAlignmentX() );
        Bsimpan.setIconTextGap( Bkosongkan.getIconTextGap() );
        Bsimpan.setBounds( Bkosongkan.getX()-Bkosongkan.getWidth(), Bkosongkan.getY(), Bkosongkan.getWidth()-10, Bkosongkan.getHeight() );//java default
        Bsimpan.setMnemonic('S');  Bsimpan.addFocusListener(retail.onHover);
        Bsimpan.setEnabled(false);

        panel.add(Bsimpan);
        panel.add(Bkosongkan);
        panel.add(Bkeluar);

        getContentPane().add(panel);
        pack();
        setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);

        Bsimpan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
//try{
            if( retail.empty( mandatory.toArray( new JTextComponent[mandatory.size()] ) )) return;
            if( !build_sql() ) return;
            db.exec(sql, params, true);
            if( db.err_msg.equals("") ) Bkosongkan.doClick();
            else JOptionPane.showMessageDialog( Ftambah.this, db.err_msg, modul + " Gagal", JOptionPane.ERROR_MESSAGE);
//} catch (Exception ex) {    JOptionPane.showMessageDialog( null, "from regfresss\n. Pesan Kesalahan: " + ex, "refress", JOptionPane.ERROR_MESSAGE); }
        }});
        Bkosongkan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
                Component comp_first=null;
                for(Component comp : panel.getComponents())
                    if( comp instanceof JTextField || comp instanceof JPasswordField ) {
                        ((JTextComponent)comp).setText("");
                        if( comp_first==null ) comp_first=comp;
                    }
                Bkosongkan.setEnabled(false);    Bsimpan.setEnabled(false);
                if( comp_first!=null ) comp_first.requestFocus();
        }});

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                if( !Bsimpan.isEnabled() ) { close(); return; }
                int resp = JOptionPane.showOptionDialog( retail.f, "\nPerubahan data ingin disimpan?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                if( resp==0 ) { //"YA"
                    Bsimpan.doClick();
                    if( !Bsimpan.isEnabled() ) close();
                } else if( resp==1 ) { //"TIDAK"
                    close();
                }
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  @Override public void windowClosing(WindowEvent e) {
                Bkeluar.doClick();
        }});

        retail.removeTitleButtons(this, onClose);
        retail.addEnterToTraversalKeys(this);
    }
    void close() {
        db.close(); dispose();
    }

    protected void align_comps() {
        int ci=0;   String filter_pre;    //JTextField last_field=null;
        for( Component comp : panel.getComponents() ) {
            if( comp instanceof JTextField || comp instanceof JPasswordField ) {
                JTextComponent tc = (JTextComponent)comp;
                AbstractDocument doc = (AbstractDocument) tc.getDocument();
                doc.putProperty("tombol_to_enable", new JButton[]{Bsimpan, Bkosongkan} );
                if( comp_number.contains(comp) )
                    filter_pre = (retail.convert_null(comp.getName()).equals("enable_sign")?"^-?":"") + "\\d{0,";   //"\\d{1," >> dia lakukan validasi klo disetText("") atau setText(null) dari code
                else
                    filter_pre = ".{0,";    //\\w{0, >> A word character: [\p{Alpha}\p{gc=Mn}\p{gc=Me}\p{gc=Mc}\p{Digit}\p{gc=Pc}]
                doc.setDocumentFilter(new PatternFilter( filter_pre + (int)((JTextField)comp).getColumns() + "}" ));
                doc.addDocumentListener(retail.enable_on_change);
                tc.setMargin( new Insets( 0, 7, 0, 0 ) );
                //last_field = tc;
            }
            if( comp instanceof JLabel || comp instanceof JTextField || comp instanceof JPasswordField || comp instanceof JComboBox ) {
                ci = panel.getComponentZOrder(comp);
                if( ci>=3+2 ) comp.setBounds( panel.getComponent(ci-2).getX(), panel.getComponent(ci-2).getY()+40, panel.getComponent(ci-2).getWidth(), panel.getComponent(ci-2).getHeight() );
                if( comp instanceof JLabel ) { //set agar field dapat requestfocus saat labelnya diakses via "mnemonic" key...
                    JLabel label = (JLabel)comp;
                    label.setLabelFor( panel.getComponent(ci+1) );
                    label.setDisplayedMnemonic( label.getText().charAt(0) );
                    if( label.getDisplayedMnemonic()=='K' ) label.setDisplayedMnemonic( 'E' );    //K tu da dipakai tombol Keluar .... //if( ((JTextComponent)label.getLabelFor()).getText().indexOf("Keterangan")>=0 ) label.setDisplayedMnemonic( 'T' );
                }
            }
        }

/* hadeh .. kebentur retail.addEnterToTraversalKeys(this) di atas :p ... solve this via eventdispatcher!!:)
//      if( ci>0 && last_field!=null && panel.getComponent(ci+1) instanceof JButton ) {
        if( ci>0 && last_field!=null ) {
            final JButton button = ((JButton)panel.getComponent(0));
            last_field.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                JOptionPane.showMessageDialog( null, "action", "refress", JOptionPane.ERROR_MESSAGE);
                button.doClick();
            }});    //for the last text component .. invoke the button (simpan) hehe
        }
*/

    }

    Boolean build_sql() {
        return false;
    }
}