/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.io.File;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

public class Ftambah_barang extends JDialog {
    public JBprint Bprint_barcode, Bprint_label_rak;    public JButton Bambil_gambar, Bsimpan, Bkosongkan;
    private db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    BufferedImage BIgambar = null;
    String ext = "";
    JCdb Cagent=null;
    JLabel Lrangkap;
    JComboBox Ccopies;
    Boolean printer_barcode   = retail.convert_null(retail.setting.get("Aktifkan Printer Barcode")).toLowerCase().equals("ya");
    Boolean printer_label_rak = retail.convert_null(retail.setting.get("Aktifkan Printer Label Rak")).toLowerCase().equals("ya");
    String saved_code = "";    String saved_name = "";    String saved_harga = "";    String saved_deskripsi = "";
    public Ftambah_barang(final Window parent) {    //JFrame parent
        this(parent, "");
    }
    public Ftambah_barang(final Window parent, final String barcode_init) {    //JFrame parent
        super( parent, retail.app_name + " - Tambah Barang" + "   ::   Petugas: " + retail.nama, Dialog.ModalityType.APPLICATION_MODAL);
        final String modul = "Tambah Data Barang";
        String err_msg = "";
        setIconImage(retail.icon_app);
        final Boolean disc_qty  = retail.convert_null(retail.setting.get("Aktifkan Diskon Quantity")).toLowerCase().equals("ya");
        setMinimumSize( new Dimension(970+(disc_qty?50:0), 650+50) );

        final JPanel panel = new JPanel();
	panel.setLayout(null);
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(26, 16, 65, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Tambah Barang" ) ) );

        JLabel Lname = new JLabel("Nama Barang", JLabel.RIGHT);
        Lname.setBounds( (disc_qty?50:30), 80, 150, 35);  panel.add(Lname);
        final JTextField Tname = new JTextField(50);//  column di sini yg jelas dipakai utk patternfilter ngebatasi maks karakter
        Tname.setBounds( 15 + panel.getComponent(0).getX() + panel.getComponent(0).getWidth(), panel.getComponent(0).getY()+3, 200, 29 );  panel.add(Tname);

        JLabel Lcode = new JLabel("Kode Barang", JLabel.RIGHT);  panel.add(Lcode);
        final JTextField Tcode = new JTextField(20);  panel.add(Tcode);    Tcode.setName("barcode target");    //utk dipakai di event dispatcher agar barcode hanya bisa masuk sini.
        Tcode.setText(barcode_init);    //initial value from caller

        JLabel Lstok = new JLabel("Stok", JLabel.RIGHT);  panel.add(Lstok);
        final JTextField Tstok = new JTextField(4);  panel.add(Tstok);

        JLabel Lsize = new JLabel("Ukuran / Size", JLabel.RIGHT);  panel.add(Lsize);
        final JTextField Tsize = new JTextField(30);  panel.add(Tsize);

        JLabel Lberat = new JLabel("Berat (gram)", JLabel.RIGHT);  panel.add(Lberat);
        final JTextField Tberat = new JTextField(6);  panel.add(Tberat);

        JLabel Lomset = new JLabel("Omset / bln", JLabel.RIGHT);  panel.add(Lomset);
        final JTextField Tomset = new JTextField(4);  panel.add(Tomset);

        JLabel Ldeskripsi = new JLabel("Deskripsi Barang", JLabel.RIGHT);  panel.add(Ldeskripsi);
        final JTextField Tdeskripsi = new JTextField(255);  panel.add(Tdeskripsi);

        JLabel Lharga_beli = new JLabel("Harga Beli (Rp)", JLabel.RIGHT);  panel.add(Lharga_beli);
        final JTextField Tharga_beli = new JTextField(9);  panel.add(Tharga_beli);
        //You can set an InputVerifier that: http://stackoverflow.com/questions/2234726/jformattedtextfield-input-time-duration-value/2241997#2241997
        //JFormattedTextField field = new JFormattedTextField( new NumberFormatter(NumberFormat.getNumberInstance(Locale.UK)) );  //JFormattedTextField txtTax = new javax.swing.JFormattedTextField(); txtTax.setFormatterFactory(new DefaultFormatterFactory(new NumberFormatter(new DecimalFormat("#,##0.00", new DecimalFormatSymbols(new Locale("us", "EN"))))));

        JLabel Ldiskon_beli = new JLabel("Diskon Beli", JLabel.RIGHT);  panel.add(Ldiskon_beli);
        final JTextField Tdiskon_beli = new JTextField(2);  panel.add(Tdiskon_beli);

        final Boolean sup_akses = retail.hak_akses.indexOf("'Supplier di Fitur Barang'") >= 0 ;
        if( sup_akses ) {
            JLabel Lagent = new JLabel("Supplier", JLabel.RIGHT);  panel.add(Lagent);
            Cagent = new JCdb("SELECT id, name, code, kontak, diskon FROM supplier ORDER BY IF(id=1,-111,name)");  panel.add(Cagent);
        }

        JLabel Lharga_jual = new JLabel("Harga Jual (Rp)", JLabel.RIGHT);  panel.add(Lharga_jual);
        final JTextField Tharga_jual = new JTextField(9);  panel.add(Tharga_jual);

        JLabel Ldiskon_jual = new JLabel("Diskon Jual", JLabel.RIGHT);  panel.add(Ldiskon_jual);
        final JTextField Tdiskon_jual = new JTextField(2);  panel.add(Tdiskon_jual);


        JLabel     Lqty1         = new JLabel("Qty1", JLabel.RIGHT);         panel.add(Lqty1);
        final JTextField Tqty1   = new JTextField(4);  Tqty1.setHorizontalAlignment(JTextField.RIGHT);  panel.add(Tqty1);
        JLabel     Ldisc_amount1 = new JLabel("Diskon", JLabel.RIGHT);  panel.add(Ldisc_amount1);
        final JTextField Tdisc_amount1 = new JTextField(9);  Tdisc_amount1.setHorizontalAlignment(JTextField.RIGHT);  panel.add(Tdisc_amount1);

        JLabel     Lqty2         = new JLabel("Qty2", JLabel.RIGHT);         panel.add(Lqty2);
        final JTextField Tqty2   = new JTextField(4);  Tqty2.setHorizontalAlignment(JTextField.RIGHT);  panel.add(Tqty2);
        JLabel     Ldisc_amount2 = new JLabel("Diskon", JLabel.RIGHT);  panel.add(Ldisc_amount2);
        final JTextField Tdisc_amount2 = new JTextField(9);  Tdisc_amount2.setHorizontalAlignment(JTextField.RIGHT);  panel.add(Tdisc_amount2);

        JLabel     Lqty3         = new JLabel("Qty3", JLabel.RIGHT);         panel.add(Lqty3);
        final JTextField Tqty3   = new JTextField(4);  Tqty3.setHorizontalAlignment(JTextField.RIGHT);  panel.add(Tqty3);
        JLabel     Ldisc_amount3 = new JLabel("Diskon", JLabel.RIGHT);  panel.add(Ldisc_amount3);
        final JTextField Tdisc_amount3 = new JTextField(9);  Tdisc_amount3.setHorizontalAlignment(JTextField.RIGHT);  panel.add(Tdisc_amount3);

        JLabel     Lqty4         = new JLabel("Qty4", JLabel.RIGHT);         panel.add(Lqty4);
        final JTextField Tqty4   = new JTextField(4);  Tqty4.setHorizontalAlignment(JTextField.RIGHT);  panel.add(Tqty4);
        JLabel     Ldisc_amount4 = new JLabel("Diskon", JLabel.RIGHT);  panel.add(Ldisc_amount4);
        final JTextField Tdisc_amount4 = new JTextField(9);  Tdisc_amount4.setHorizontalAlignment(JTextField.RIGHT);  panel.add(Tdisc_amount4);

        final JBkeluar Bkeluar = new JBkeluar(this);

        Bkosongkan = new JButton("F5 - kosongkan", retail.icon_reset);
        Bkosongkan.setAlignmentX( Bkeluar.getAlignmentX() );
        Bkosongkan.setIconTextGap( Bkeluar.getIconTextGap() );
        Bkosongkan.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-10-30, Bkeluar.getY(), Bkeluar.getWidth()+30, Bkeluar.getHeight() );//java default
        Bkosongkan.setMnemonic('O');  Bkosongkan.addFocusListener(retail.onHover);
        Bkosongkan.setEnabled(false);

        Bsimpan = new JButton("F10 - simpan", retail.icon_save );
        Bsimpan.setAlignmentX( Bkosongkan.getAlignmentX() );
        Bsimpan.setIconTextGap( Bkosongkan.getIconTextGap() );
        Bsimpan.setBounds( Bkosongkan.getX()-Bkosongkan.getWidth(), Bkosongkan.getY(), Bkosongkan.getWidth()-10, Bkosongkan.getHeight() );//java default
        Bsimpan.setMnemonic('S');  Bsimpan.addFocusListener(retail.onHover);
        Bsimpan.setEnabled(false);

        panel.add(Bsimpan);
        panel.add(Bkosongkan);
        panel.add(Bkeluar);

        final JLabel Lgambar = new JLabel( "[ Gambar ]", JLabel.CENTER );    Lgambar.setForeground(Color.GRAY);

        int ci=0;   String filter_pre;
        for( Component comp : panel.getComponents() ) {
            if( comp instanceof JTextField ) {
                final JTextComponent tc = (JTextComponent)comp;
                AbstractDocument doc = (AbstractDocument) tc.getDocument();
                JButton[] tombol;
                /* ga jadi ... print hanya boleh klo da simpan aja :p...
                if( printer_barcode ) {
                    if( printer_label_rak )    tombol = new JButton[]{Bsimpan, Bkosongkan, Bprint_barcode, Bprint_label_rak};
                    else                       tombol = new JButton[]{Bsimpan, Bkosongkan, Bprint_barcode};
                } else if( printer_label_rak ) tombol = new JButton[]{Bsimpan, Bkosongkan, Bprint_label_rak};
                else
                */
                tombol = new JButton[]{Bsimpan, Bkosongkan};
                if( printer_barcode || printer_label_rak )    //disable them :p
                    doc.addDocumentListener( new DocumentListener() {
                        public void changedUpdate(DocumentEvent e) {
                            if( tc.getText().isEmpty() ) return;
                            if( printer_barcode   ) {
                                Bprint_barcode.setEnabled(false);
                                Ccopies.setEnabled(false);    Lrangkap.setEnabled(false);
                            }
                            if( printer_label_rak ) Bprint_label_rak.setEnabled(false);
                        }
                        public void removeUpdate(DocumentEvent e) { changedUpdate(e); }
                        public void insertUpdate(DocumentEvent e) { changedUpdate(e); }
                });
                doc.putProperty("tombol_to_enable", tombol);
                if( comp==Tstok || comp==Tberat || comp==Tomset || comp==Tharga_beli || comp==Tharga_jual || comp==Tdiskon_beli || comp==Tdiskon_jual || comp==Tdisc_amount1 || comp==Tdisc_amount2 || comp==Tdisc_amount3 || comp==Tdisc_amount4 )
                    filter_pre = "\\d{0,";   //"\\d{1," >> dia lakukan validasi klo disetText("") atau setText(null) dari code
                else
                    filter_pre = ( comp==Tcode ? "ean13" : "" )    + ".{0,";    //\\w{0, >> A word character: [\p{Alpha}\p{gc=Mn}\p{gc=Me}\p{gc=Mc}\p{Digit}\p{gc=Pc}]
                doc.setDocumentFilter(new PatternFilter( filter_pre + (int)((JTextField)comp).getColumns() + "}" ));
                doc.addDocumentListener(retail.enable_on_change);
                if( ! (comp==Tqty1 || comp==Tqty2 || comp==Tqty3 || comp==Tqty4 || comp==Tdisc_amount1 || comp==Tdisc_amount2 || comp==Tdisc_amount3 || comp==Tdisc_amount4 ) )
                    tc.setMargin( new Insets( 0, 7, 0, 0 ) );
            }
            if( comp instanceof JLabel || comp instanceof JTextField || comp instanceof JComboBox ) {
                ci = panel.getComponentZOrder(comp);
                if( ci>=2 && ci<100) comp.setBounds( panel.getComponent(ci-2).getX(), panel.getComponent(ci-2).getY()+40, panel.getComponent(ci-2).getWidth(), panel.getComponent(ci-2).getHeight() );
                if( comp instanceof JLabel ) { //set agar field dapat requestfocus saat labelnya diakses via "mnemonic" key...
                    JLabel label = (JLabel)comp;
                    label.setLabelFor( panel.getComponent(ci+1) );
                         if( label==Lname       ) label.setDisplayedMnemonic( 'A' );
                    else if( label==Lcode       ) label.setDisplayedMnemonic( 'D' );
                    else if( label==Lstok       ) label.setDisplayedMnemonic( 'O' );
                    else if( label==Lberat      ) label.setDisplayedMnemonic( '(' );
                    else if( label==Lomset      ) label.setDisplayedMnemonic( 'M' );
                    else if( label==Lharga_beli ) label.setDisplayedMnemonic( 'E' );
                    else if( label==Lharga_jual ) label.setDisplayedMnemonic( 'J' );
                    else if( label==Ldeskripsi  ) label.setDisplayedMnemonic( 'R' );
                    else if( label!=Lgambar && label!=Ldisc_amount1 && label!=Lqty2 && label!=Lqty3 && label!=Lqty4    &&    label!=Ldisc_amount1 && label!=Ldisc_amount2 && label!=Ldisc_amount3 && label!=Ldisc_amount4    )
                                                  label.setDisplayedMnemonic( label.getText().charAt(0) );
                }
            }
        }

        JPopupMenu popup = new JPopupMenu();
        final JMenuItem menu_hapus_gambar = new JMenuItem("Hapus gambar ...", retail.icon_delete_image);
        menu_hapus_gambar.setMnemonic('H');
        menu_hapus_gambar.setEnabled(false);
        popup.add(menu_hapus_gambar);
        Lgambar.setComponentPopupMenu(popup);

        final JButton Bganti_gambar = new JButton("File Gambar", retail.icon_image);
        Bganti_gambar.setAlignmentX ( Bkeluar.getAlignmentX() );
        Bganti_gambar.setIconTextGap( Bkeluar.getIconTextGap() );
        Bganti_gambar.setBounds(getWidth() - Tname.getX() - Tname.getWidth() + 100, Tname.getY(), 206-50-1, 33 + 2); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default
        Bganti_gambar.setMnemonic('G');  Bganti_gambar.addFocusListener(retail.onHover);
        panel.add(Bganti_gambar);

        Bambil_gambar = new JButton("", retail.icon_camera);
        Bambil_gambar.setAlignmentX ( Bkeluar.getAlignmentX() );
        Bambil_gambar.setIconTextGap( Bkeluar.getIconTextGap() );
        Bambil_gambar.setBounds( Bganti_gambar.getX()+Bganti_gambar.getWidth() + 1, Bganti_gambar.getY(), 50, Bganti_gambar.getHeight()); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default
        Bambil_gambar.setMnemonic('T');  Bambil_gambar.addFocusListener(retail.onHover);
        Bambil_gambar.setToolTipText("F4 - Ambil Foto");
        panel.add(Bambil_gambar);

        final JButton Bhapus_gambar = new JButton("Hapus gambar", retail.icon_delete_image);
        Bhapus_gambar.setAlignmentX( Bkeluar.getAlignmentX() );
        Bhapus_gambar.setIconTextGap( Bkeluar.getIconTextGap() );
        Bhapus_gambar.setMnemonic('H');  Bhapus_gambar.addFocusListener(retail.onHover);
        Bhapus_gambar.setEnabled(false);
        panel.add(Bhapus_gambar);
        ActionListener act_hapus_gambar = new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
                //doesn't work as I expected :) ... hrsnya direkam dulu last focused componentnya ... Bhapus_gambar.transferFocusBackward();
                Lgambar.setIcon(null);
                Lgambar.setText( "[ Gambar ]" );
                Bhapus_gambar.setEnabled(false);    menu_hapus_gambar.setEnabled(false);
                //ga jadi ... Bganti_gambar.setText( "Masukkan Gambar" );  //hehe
        }};
        Bhapus_gambar.addActionListener(act_hapus_gambar);
        menu_hapus_gambar.addActionListener(act_hapus_gambar);

        Bganti_gambar.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
            BIgambar = retail.load( Lgambar, "" );
            if( BIgambar==null ) return;
            ext = retail.ext( retail.file_dialog.getSelectedFile().getName() );  //to beware if this open_file used by another thread
            //ga usah lah, biar jtextfield aja yg mengenable ini >> Bsimpan.setEnabled(true);    Bkosongkan.setEnabled(true);
        }});
        Bambil_gambar.addActionListener(new ActionListener() { @Override public void actionPerformed(ActionEvent e) {
            BIgambar = retail.load_scan(Lgambar);
            if( BIgambar==null ) return;
            ext = ".jpg";
            //ga usah lah, biar jtextfield aja yg mengenable ini >> Bsimpan.setEnabled(true);    Bkosongkan.setEnabled(true);
        }});

        Lgambar.setBounds( Bganti_gambar.getX()+3, Bganti_gambar.getY()+Bganti_gambar.getHeight()+5, Bambil_gambar.getX() - Bganti_gambar.getX() + Bambil_gambar.getWidth() -6, Bambil_gambar.getX() - Bganti_gambar.getX() + Bambil_gambar.getWidth() -6 ); //ah ribet deh:p >> panel.getBorder().getInsideBorder().getBorderInsets().left    java default
        //Lgambar.setBorder( BorderFactory.createCompoundBorder( BorderFactory.createLoweredBevelBorder() , BorderFactory.createRaisedBevelBorder() ) );
        Lgambar.setBorder( BorderFactory.createLoweredBevelBorder() );
        //Lgambar.setBorder( BorderFactory.createCompoundBorder( BorderFactory.createRaisedBevelBorder(), BorderFactory.createLoweredBevelBorder() ) );
        panel.add(Lgambar);
        Lgambar.addMouseListener( new MouseAdapter() { public void mouseClicked(MouseEvent e) {  //A mouseClicked event is only fired when a mousePressed and mouseReleased event is generated at the same pixel location
            if( e.getClickCount() >= 2 ) Bganti_gambar.doClick();
        }});

        Bhapus_gambar.setBounds( Bganti_gambar.getX(), Lgambar.getY()+Lgambar.getHeight()+5, Lgambar.getWidth() +6, Bganti_gambar.getHeight() );

        if( printer_label_rak ) {
            Bprint_label_rak = new JBprint(this, (byte)4);
            Bprint_label_rak.setBounds( Bhapus_gambar.getX(), Bhapus_gambar.getY()+50, Bhapus_gambar.getWidth(), Bhapus_gambar.getHeight() );    panel.add(Bprint_label_rak);
            Bprint_label_rak.setEnabled(false);
        }
        if( printer_barcode ) {
            Bprint_barcode = new JBprint(this, (byte)3);
            Bprint_barcode.setBounds( Bhapus_gambar.getX(), Bhapus_gambar.getY()+50+5+35, Bhapus_gambar.getWidth(), Bhapus_gambar.getHeight() );    panel.add(Bprint_barcode);
            Bprint_barcode.setEnabled(false);

            String[] cp = new String[1000];              //harus String[] >> int[] cp = new int[1000];
            for( int i=0; i<1000; i++ ) cp[i]=""+(i+1);    //for( int i=0; i<1000; i++ ) cp[i]=i+1;
            Ccopies = new JComboBox(cp);
            JComponent c = (JComponent)Ccopies.getRenderer();  
            c.setBorder( BorderFactory.createEmptyBorder( 4, 10, 4, 4 ) );  
            Ccopies.setRenderer( (ListCellRenderer)c );
            Ccopies.setSelectedIndex(2);
            Ccopies.addItemListener( new ItemListener() { public void itemStateChanged(ItemEvent e) {
                if( e.getStateChange()!=ItemEvent.SELECTED ) return;
                printer_barcode_set_copies();
            }});
            Ccopies.setBounds( Bprint_barcode.getX() + Bprint_barcode.getWidth() - 60, Bprint_barcode.getY()+Bprint_barcode.getHeight()+1, 60, Bprint_barcode.getHeight() );    panel.add(Ccopies);
            Ccopies.setEnabled(false);
            Lrangkap = new JLabel("Rangkap", JLabel.RIGHT);    Lrangkap.setLabelFor( Ccopies );    Lrangkap.setDisplayedMnemonic( 'N' );
            Lrangkap.setBounds( Ccopies.getX()-80-5, Ccopies.getY(), 80, Ccopies.getHeight() );  panel.add(Lrangkap);
            Lrangkap.setEnabled(false);
        }

        getContentPane().add(panel);
        pack();
        setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);

        //customize size ...
        Tstok.setSize( new Dimension(70, Tname.getHeight()) );
        Tname.setSize( new Dimension(300, Tname.getHeight()) );
        Tcode.setSize( new Dimension(130, Tname.getHeight()) );
        Tberat.setSize( new Dimension(100, Tname.getHeight()) );
        Tomset.setSize( new Dimension(70, Tname.getHeight()) );
        Tdeskripsi.setSize( new Dimension(400, Tname.getHeight()) );
        Tdiskon_beli.setSize( new Dimension(40, Tname.getHeight()) );
        Tdiskon_jual.setSize( new Dimension(40, Tname.getHeight()) );

        JLabel Ldiskon_persen_beli = new JLabel("%");  Ldiskon_persen_beli.setBounds( Tdiskon_beli.getX() + Tdiskon_beli.getWidth(), Tdiskon_beli.getY(), 25, Tdiskon_beli.getHeight() );  panel.add(Ldiskon_persen_beli);
        JLabel Ldiskon_persen_jual = new JLabel("%");  Ldiskon_persen_jual.setBounds( Tdiskon_jual.getX() + Tdiskon_jual.getWidth(), Tdiskon_jual.getY(), 25, Tdiskon_jual.getHeight() );  panel.add(Ldiskon_persen_jual);

        if( disc_qty ) {
            Lqty1.setBounds( Ldiskon_persen_jual.getX() + Ldiskon_persen_jual.getWidth(), Ldiskon_persen_jual.getY(), 42, Ldiskon_persen_jual.getHeight() );
            Tqty1.setBounds( Lqty1.getX() + Lqty1.getWidth(), Lqty1.getY(), 30, Lqty1.getHeight() );
            Ldisc_amount1.setBounds( Tqty1.getX() + Tqty1.getWidth(), Lqty1.getY(), 45, Lqty1.getHeight() );
            Tdisc_amount1.setBounds( Ldisc_amount1.getX() + Ldisc_amount1.getWidth(), Ldisc_amount1.getY(), 55, Ldisc_amount1.getHeight() );

            Lqty2.setBounds( Tdisc_amount1.getX() + Tdisc_amount1.getWidth(), Lqty1.getY(), Lqty1.getWidth(), Lqty1.getHeight() );
            Tqty2.setBounds( Lqty2.getX() + Lqty2.getWidth(), Lqty2.getY(), Tqty1.getWidth(), Lqty2.getHeight() );
            Ldisc_amount2.setBounds( Tqty2.getX() + Tqty2.getWidth(), Lqty1.getY(), Ldisc_amount1.getWidth(), Lqty1.getHeight() );
            Tdisc_amount2.setBounds( Ldisc_amount2.getX() + Ldisc_amount2.getWidth(), Ldisc_amount2.getY(), Tdisc_amount1.getWidth(), Ldisc_amount2.getHeight() );

            Lqty3.setBounds( Tdisc_amount2.getX() + Tdisc_amount2.getWidth(), Lqty1.getY(), Lqty1.getWidth(), Lqty1.getHeight() );
            Tqty3.setBounds( Lqty3.getX() + Lqty3.getWidth(), Lqty3.getY(), Tqty1.getWidth(), Lqty3.getHeight() );
            Ldisc_amount3.setBounds( Tqty3.getX() + Tqty3.getWidth(), Lqty1.getY(), Ldisc_amount1.getWidth(), Lqty1.getHeight() );
            Tdisc_amount3.setBounds( Ldisc_amount3.getX() + Ldisc_amount3.getWidth(), Ldisc_amount3.getY(), Tdisc_amount1.getWidth(), Ldisc_amount3.getHeight() );

            Lqty4.setBounds( Tdisc_amount3.getX() + Tdisc_amount3.getWidth(), Lqty1.getY(), Lqty1.getWidth(), Lqty1.getHeight() );
            Tqty4.setBounds( Lqty4.getX() + Lqty4.getWidth(), Lqty4.getY(), Tqty1.getWidth(), Lqty4.getHeight() );
            Ldisc_amount4.setBounds( Tqty4.getX() + Tqty4.getWidth(), Lqty1.getY(), Ldisc_amount1.getWidth(), Lqty1.getHeight() );
            Tdisc_amount4.setBounds( Ldisc_amount4.getX() + Ldisc_amount4.getWidth(), Ldisc_amount4.getY(), Tdisc_amount1.getWidth(), Ldisc_amount4.getHeight() );
        } else {
            Lqty1.setVisible(false);  Tqty1.setVisible(false);  Ldisc_amount1.setVisible(false);  Tdisc_amount1.setVisible(false);
            Lqty2.setVisible(false);  Tqty2.setVisible(false);  Ldisc_amount2.setVisible(false);  Tdisc_amount2.setVisible(false);
            Lqty3.setVisible(false);  Tqty3.setVisible(false);  Ldisc_amount3.setVisible(false);  Tdisc_amount3.setVisible(false);
            Lqty4.setVisible(false);  Tqty4.setVisible(false);  Ldisc_amount4.setVisible(false);  Tdisc_amount4.setVisible(false);
        }

        Bsimpan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            if( retail.empty( new JTextComponent[]{ Tname, Tcode, Tharga_jual } )) return;
            String sql = " INSERT INTO barang (            id         , name, code, berat, stok, omset, size, deskripsi, harga_beli, diskon_beli, harga_jual, diskon_jual, gambar, supplier_id, disc_qty1, disc_amount1, disc_qty2, disc_amount2, disc_qty3, disc_amount3, disc_qty4, disc_amount4 ) "  //field gambar ini minimal digunakan utk cek saat view Fedit agar ga nyari terus ke harddisk:)
                       + " SELECT              IFNULL( MAX(id), 0) + 1,   ? ,   ? ,   ?  ,   ?  ,   ?  ,   ? ,     ?    ,      ?    ,      ?     ,     ?     ,       ?    ,    ?  ,    ?       ,     ?    ,      ?      ,     ?    ,      ?      ,     ?    ,      ?      ,     ?    ,      ?          FROM barang" ;
            String gambar_filename = Tcode.getText().replaceAll("[^a-zA-Z0-9\\.\\-]", "-").trim();   //"_" mungkin hrs gini klo di linux
            gambar_filename = Lgambar.getText().equals("") ? gambar_filename + String.format( " - %1$td_%<tm_%<ty %<tH.%<tM.%<tS.%<tL", Calendar.getInstance() ) + ext : "" ;  //karena ada kemungkinan code diedit user dan saat tambah user, code yg lama bisa mengacu gambar_filename yg salah :p
            String[] params = { Tname.getText(), Tcode.getText(), Tberat.getText(), Tstok.getText(), Tomset.getText(), Tsize.getText(), Tdeskripsi.getText(), Tharga_beli.getText(), Tdiskon_beli.getText(), Tharga_jual.getText(), Tdiskon_jual.getText(), gambar_filename, (sup_akses?String.valueOf(((jcdb_item)Cagent.getSelectedItem()).get_id()):"0"), Tqty1.getText(), Tdisc_amount1.getText()  , Tqty2.getText(), Tdisc_amount2.getText()  , Tqty3.getText(), Tdisc_amount3.getText()  , Tqty4.getText(), Tdisc_amount4.getText() };
            db.exec(sql, params, true);
            if( !db.err_msg.equals("") ) { JOptionPane.showMessageDialog( Ftambah_barang.this, db.err_msg, modul + " Gagal", JOptionPane.ERROR_MESSAGE );    return; }
            if( printer_barcode ) {
                Bprint_barcode.setEnabled(true);
                Ccopies.setEnabled(true);    Lrangkap.setEnabled(true);
            }
            if( printer_label_rak ) Bprint_label_rak.setEnabled(true);
            if( printer_barcode || printer_label_rak ) {    //to print
                saved_code      = Tcode.getText().trim();
                saved_name      = Tname.getText().trim();
                saved_harga     = Tharga_jual.getText().trim().replace( retail.digit_separator, "" );
                saved_deskripsi = Tdeskripsi.getText().trim();
            }
            retail.reset_brg();
            if( Lgambar.getText() != "" ) {
                Bkosongkan.doClick();
                if( !barcode_init.isEmpty() ) Bkeluar.doClick();    //langsung keluar klo ada barcode_init heeh heee
                return;
            }
            String mime = "png";    //pingin si memaksa semua file jadi png biar load imagenya ntar cepat, tapi gimana klo file server gambar ada di jaringan? Na lo. lambat kan? Bahkan sebaiknya dipaksa ke .jpg aja deh, hmmm
            if( !ext.equals("") ) mime = ext.substring(1,ext.length());  //without dot // biar ajalah, lah png tu 10X lebih besar je ukuran filenya:) >> biar ga banyak data sampah saat gambar diedit dgn ext yg beda2
            try {  //if( !retail.copy_file( gambar_path, db.cfg.get("direktori_gambar") + Tcode.getText().trim() ) ) {    //gimana klo insert ke db gagal gara2 duplikat? hahaha .... mestinya save file diundo krn dia terlanjur nimpa file lain:p >> save gambar dulu agar klo gagal, ga insert ke db
                ImageIO.write( BIgambar, mime, new File( db.cfg.get("direktori_gambar")+gambar_filename ) );    //then save file!
                //ga iso, tetap harus didefine di class utama >>  throw new RuntimeException("Penyimpanan file gambar gagal!");
                Bkosongkan.doClick();
                if( !barcode_init.isEmpty() ) Bkeluar.doClick();    //langsung keluar klo ada barcode_init heeh heee
            } catch( Exception ex ) {
                sql = "DELETE FROM barang WHERE code=? LIMIT 1" ;
                params = new String[]{ Tcode.getText() };
                db.exec(sql, params, true);
                JOptionPane.showMessageDialog( Ftambah_barang.this, "\nPenyimpanan file gambar gagal!\nPesan Kesalahan: " +ex+ "\n\n\n\n" , "Kesalahan", JOptionPane.ERROR_MESSAGE );
                return;
            } finally {
                BIgambar.flush();    BIgambar = null;
            }
        }});

        Bkosongkan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
                for(Component comp : panel.getComponents())
                    if( comp instanceof JTextField ) ((JTextComponent)comp).setText("");
                    else if( comp instanceof JComboBox ) ((JComboBox)comp).setSelectedIndex(0);
                Bkosongkan.setEnabled(false);    Bsimpan.setEnabled(false);
                Bhapus_gambar.doClick();
                Tname.requestFocus();
        }});

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                if( !Bsimpan.isEnabled() ) { close(); return; }
                int resp = JOptionPane.showOptionDialog( retail.f, "\nPerubahan data ingin disimpan?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                if( resp==0 ) { //"YA"
                    Bsimpan.doClick();
                    if( !Bsimpan.isEnabled() ) close();
                } else if( resp==1 ) { //"TIDAK"
                    close();
                }
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  @Override public void windowClosing(WindowEvent e) {
                Bkeluar.doClick();
        }});

        retail.removeTitleButtons(this, onClose);
        retail.addEnterToTraversalKeys(this);

        CustomizedTabOrder tab_order = new CustomizedTabOrder( getFocusTraversalPolicy() );
        tab_order.bind( Tname, Tcode );
        tab_order.bind( Tharga_beli, Tdiskon_beli );
        tab_order.bind( Bkeluar, Bganti_gambar );
        tab_order.bind( Bambil_gambar, Bhapus_gambar );
        tab_order.setLastComponent( Bhapus_gambar );
        setFocusTraversalPolicy(tab_order);

        setVisible(true);
    }
    void printer_barcode_set_copies() {
        if( !printer_barcode ) return;    //&& !printer_label_rak
        String text = Bprint_barcode.getText();
        int pos = text.indexOf("(");
        if( pos>0 ) text = text.substring(0,pos).trim();
        String copies = String.valueOf( Ccopies.getSelectedIndex()+1 );
        copies = " (" + copies + ")";
        Bprint_barcode.setText(   text + copies );    Bprint_barcode.setToolTipText( text + copies + ". Tahan tombol Ctrl atau Shift untuk memilih data! ");
        //nop >> if( printer_label_rak ) Bprint_label_rak.setText( text + copies );    Blabel_rak.setToolTipText(     text + copies );
    }
    //to print
    public Object[][] title_header() {
            Object[][] title_header = {
                  { retail.convert_null(retail.setting.get("Nama Perusahaan")).toUpperCase() }
                , { saved_code  }
                , { String.format( "%1$td-%<tm-%<ty", new Date() ) }
                , { saved_name  }
                , { saved_harga }
                , { saved_deskripsi }
                };
            return title_header;
    }
    public Object[][] table_summary() {
            Object[][] table_summary = {
                };
            return table_summary;
    }
    void close() {
        db.close(); dispose();
    }
}