/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;

public class Ftambah_grup extends JDialog {
    public JButton Bsimpan;    public JButton Bkosongkan;
    private db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    public Ftambah_grup(final JFrame parent) {
        super(parent, retail.app_name + " - Tambah Grup User" + "   ::   Petugas: " + retail.nama, true);
        final String modul = "Tambah Data Grup User";
        String err_msg = "";
        setIconImage(retail.icon_app);
        setMinimumSize( new Dimension(850, 650) );

        final JPanel panel = new JPanel();
	panel.setLayout(null);
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(26, 16, 65, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Tambah Grup User" ) ) );

        JLabel Lname = new JLabel("Grup User", JLabel.LEFT);
        Lname.setBounds(70, 80, 65, 35);  panel.add(Lname);
        final JTextField Tname = new JTextField();  Tname.setMinimumSize( new Dimension(20, 1) );
        Tname.setBounds( 15 + panel.getComponent(0).getX() + panel.getComponent(0).getWidth(), panel.getComponent(0).getY()+3, 200, 29 );  panel.add(Tname);

        JLabel Lketerangan = new JLabel("Keterangan", JLabel.LEFT);  panel.add(Lketerangan);
        final JTextField Tketerangan = new JTextField();  Tketerangan.setMinimumSize( new Dimension(255, 1) );  panel.add(Tketerangan);

        final JBkeluar Bkeluar = new JBkeluar(this);

        Bkosongkan = new JButton("F5 - kosongkan", retail.icon_reset);
        Bkosongkan.setAlignmentX( Bkeluar.getAlignmentX() );
        Bkosongkan.setIconTextGap( Bkeluar.getIconTextGap() );
        Bkosongkan.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-10-30, Bkeluar.getY(), Bkeluar.getWidth()+30, Bkeluar.getHeight() );//java default
        Bkosongkan.setMnemonic('O');  Bkosongkan.addFocusListener(retail.onHover);
        Bkosongkan.setEnabled(false);

        Bsimpan = new JButton("F10 - simpan", retail.icon_save );
        Bsimpan.setAlignmentX( Bkosongkan.getAlignmentX() );
        Bsimpan.setIconTextGap( Bkosongkan.getIconTextGap() );
        Bsimpan.setBounds( Bkosongkan.getX()-Bkosongkan.getWidth(), Bkosongkan.getY(), Bkosongkan.getWidth()-10, Bkosongkan.getHeight() );//java default
        Bsimpan.setMnemonic('S');  Bsimpan.addFocusListener(retail.onHover);
        Bsimpan.setEnabled(false);

        panel.add(Bsimpan);
        panel.add(Bkosongkan);
        panel.add(Bkeluar);

        getContentPane().add(panel);
        pack();
        setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);

        int ci=0;
        for( Component comp : panel.getComponents() ) {
            if( comp instanceof JTextField ) {
                JTextComponent tc = (JTextComponent)comp;
                AbstractDocument doc = (AbstractDocument) tc.getDocument();
                doc.putProperty("tombol_to_enable", new JButton[]{Bsimpan, Bkosongkan} );
                doc.setDocumentFilter(new PatternFilter( ".{0," + (int)comp.getMinimumSize().getWidth() + "}" ));
                doc.addDocumentListener(retail.enable_on_change);
                tc.setMargin( new Insets( 0, 7, 0, 0 ) );
            }
            if( comp instanceof JLabel || comp instanceof JTextField ) {
                ci = panel.getComponentZOrder(comp);
                if( ci>=2 ) comp.setBounds( panel.getComponent(ci-2).getX(), panel.getComponent(ci-2).getY()+40, panel.getComponent(ci-2).getWidth(), panel.getComponent(ci-2).getHeight() );
                if( comp instanceof JLabel ) { //set agar field dapat requestfocus saat labelnya diakses via "mnemonic" key...
                    JLabel label = (JLabel)comp;
                    label.setLabelFor( panel.getComponent(ci+1) );
                    label.setDisplayedMnemonic( label.getText().charAt(0) );
                }
            }
        }

        //customize size ...
        Tketerangan.setSize( new Dimension(500, Tname.getHeight()) );

        Bsimpan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            if( retail.empty( new JTextComponent[]{ Tname } )) return;

            String sql = " INSERT INTO user_grup (            id         , name, keterangan ) "
                       + " SELECT                 IFNULL( MAX(id), 0) + 1,   ? ,     ?        FROM user_grup" ;
            String[] params = { Tname.getText(), Tketerangan.getText() };
            db.exec(sql, params, true);
            if( db.err_msg.equals("") ) Bkosongkan.doClick();
            else JOptionPane.showMessageDialog( Ftambah_grup.this, db.err_msg, modul + " Gagal", JOptionPane.ERROR_MESSAGE);
        }});

        Bkosongkan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
                for(Component comp : panel.getComponents())
                    if( comp instanceof JTextField ) ((JTextComponent)comp).setText("");
                Bkosongkan.setEnabled(false);    Bsimpan.setEnabled(false);
                Tname.requestFocus();
        }});

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                if( !Bsimpan.isEnabled() ) { close(); return; }
                int resp = JOptionPane.showOptionDialog( retail.f, "\nPerubahan data ingin disimpan?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                if( resp==0 ) { //"YA"
                    Bsimpan.doClick();
                    if( !Bsimpan.isEnabled() ) close();
                } else if( resp==1 ) { //"TIDAK"
                    close();
                }
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  @Override public void windowClosing(WindowEvent e) {
                Bkeluar.doClick();
        }});

        retail.removeTitleButtons(this, onClose);
        retail.addEnterToTraversalKeys(this);

        setVisible(true);
    }
    void close() {
        db.close(); dispose();
    }
}