/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;

public class Ftambah_grup_modul extends JDialog {
    public JButton Bsimpan;    public JButton Bkosongkan;
    private db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    Boolean is_saved=false;
    public Ftambah_grup_modul(final JFrame parent) {
        super(parent, retail.app_name + " - Tambah Hak Akses Modul" + "   ::   Petugas: " + retail.nama, true);
        final String modul = "Tambah Hak Akses Modul";
        String err_msg = "";
        setIconImage(retail.icon_app);
        setMinimumSize( new Dimension(850, 650) );

        final JPanel panel = new JPanel();
	panel.setLayout(null);
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(26, 16, 65, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Tambah Hak Akses Modul" ) ) );

        JLabel Lgrup = new JLabel("Grup User", JLabel.LEFT);
        Lgrup.setBounds(70, 80, 65, 35);  panel.add(Lgrup);
        final JComboBox Cgrup = new JCdb("user_grup");
        err_msg += db.err_msg;
        Cgrup.setBounds( 15 + panel.getComponent(0).getX() + panel.getComponent(0).getWidth(), panel.getComponent(0).getY()+3, 330, 29 );
        panel.add(Cgrup);

        final JLabel Lmodul = new JLabel("Modul", JLabel.LEFT);  panel.add(Lmodul);
        final JComboBox Cmodul = new JCdb("modul");
        err_msg += db.err_msg;
        Cmodul.insertItemAt( new jcdb_item( -1, "[  Pilih Modul .....  ]" ), 0); //supaya Bkosongkan ada actionnya :)
        Cmodul.setSelectedIndex(0);
        Cmodul.setMaximumRowCount(17);
        panel.add(Cmodul);

        final JBkeluar Bkeluar = new JBkeluar(this);

        Bkosongkan = new JButton("F5 - kosongkan", retail.icon_reset);
        Bkosongkan.setAlignmentX( Bkeluar.getAlignmentX() );
        Bkosongkan.setIconTextGap( Bkeluar.getIconTextGap() );
        Bkosongkan.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-10-30, Bkeluar.getY(), Bkeluar.getWidth()+30, Bkeluar.getHeight() );//java default
        Bkosongkan.setMnemonic('O');  Bkosongkan.addFocusListener(retail.onHover);
        Bkosongkan.setEnabled(false);

        Bsimpan = new JButton("F10 - simpan", retail.icon_save );
        Bsimpan.setAlignmentX( Bkosongkan.getAlignmentX() );
        Bsimpan.setIconTextGap( Bkosongkan.getIconTextGap() );
        Bsimpan.setBounds( Bkosongkan.getX()-Bkosongkan.getWidth(), Bkosongkan.getY(), Bkosongkan.getWidth()-10, Bkosongkan.getHeight() );//java default
        Bsimpan.setMnemonic('S');  Bsimpan.addFocusListener(retail.onHover);
        Bsimpan.setEnabled(false);

        panel.add(Bsimpan);
        panel.add(Bkosongkan);
        panel.add(Bkeluar);

        getContentPane().add(panel);
        pack();
        setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);

        //the events ....
        ItemListener enable_on_change_combo = new ItemListener() { public void itemStateChanged(ItemEvent e) {
            Bsimpan.setEnabled(true);
            Bkosongkan.setEnabled(true);
        }};

        int ci=0;
        for( Component comp : panel.getComponents() ) {
            if( comp instanceof JComboBox ) ((JComboBox)comp).addItemListener(enable_on_change_combo);
            if( comp instanceof JLabel || comp instanceof JComboBox ) {
                ci = panel.getComponentZOrder(comp);
                if( ci>=2 ) comp.setBounds( panel.getComponent(ci-2).getX(), panel.getComponent(ci-2).getY()+40, panel.getComponent(ci-2).getWidth(), panel.getComponent(ci-2).getHeight() );
                if( comp instanceof JLabel ) { //set agar field dapat requestfocus saat labelnya diakses via "mnemonic" key...
                    JLabel label = (JLabel)comp;
                    label.setLabelFor( panel.getComponent(ci+1) );
                    label.setDisplayedMnemonic( label.getText().charAt(0) );
                }
            }
        }

        Bsimpan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            if( Cmodul.getSelectedIndex() < 1 ) {
                JOptionPane.showMessageDialog( Ftambah_grup_modul.this, "\nMohon isi \"" + Lmodul.getText() + "\"!\n\n\n\n" , "Isian harus diperbaiki", JOptionPane.ERROR_MESSAGE);
                Cmodul.requestFocus();
                return;
            }
            String sql = " INSERT INTO user_grup_modul (  grup_id, modul_id ) "
                       + " VALUES                      (     ?   ,   ?      ) " ;
            String[] params = { String.valueOf( ((jcdb_item)Cgrup.getSelectedItem()).get_id() ) , String.valueOf( ((jcdb_item)Cmodul.getSelectedItem()).get_id() ) };

            db.exec(sql, params, true);
            if( db.err_msg.equals("") ) { is_saved=true;     Bkosongkan.doClick(); }
            else JOptionPane.showMessageDialog( Ftambah_grup_modul.this, db.err_msg, modul + " Gagal", JOptionPane.ERROR_MESSAGE);
        }});

        Bkosongkan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
                Cmodul.setSelectedIndex(0);
                Bkosongkan.setEnabled(false);    Bsimpan.setEnabled(false);
                Cmodul.requestFocus();
        }});

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                if( !Bsimpan.isEnabled() ) { close(); return; }    //if( ((Window)SwingUtilities.windowForComponent((Component)e.getSource())).Bsimpan.isEnabled() ) {  //getAncestorNamed("Bsimpan", e.getSource())
                int resp = JOptionPane.showOptionDialog( retail.f, "\nPerubahan data ingin disimpan?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                if( resp==0 ) { //"YA"
                    Bsimpan.doClick();
                    if( !Bsimpan.isEnabled() ) close();
                } else if( resp==1 ) { //"TIDAK"
                    close();
                }
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  
            @Override
            public void windowClosing(WindowEvent e) {
                Bkeluar.doClick();
            }
        });

        retail.removeTitleButtons(this, onClose);
        //jadi ga bisa edit JCombo:((  retail.addUpDownToTraversalKeys(this);
        retail.addEnterToTraversalKeys(this);
        //retail.addLeftRightToTraversalKeys(this);

        if( !err_msg.equals("") ) {
            JOptionPane.showMessageDialog( this, err_msg, "Inisialisasi Data Gagal", JOptionPane.ERROR_MESSAGE);
            Bkeluar.doClick();
        } else
            setVisible(true);

    }
    void close() {
        //agak ribet klo mo restart otomatis :p >> http://stackoverflow.com/questions/4159802/how-can-i-restart-a-java-application
        if( is_saved ) JOptionPane.showMessageDialog( this, "\nMohon tutup kemudian jalankan kembali aplikasi ini untuk mengaktifkan perubahan hak akses!\n\n\n\n\n", "Mohon Jalankan Kembali Aplikasi", JOptionPane.ERROR_MESSAGE);
        db.close(); dispose();
    }
}