/*
 * Solusi Toko, Software POS/retail/inventory
 * Copyright (c) 2014-2015. Rafik, http://solusiprogram.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 */

package retail_base;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;

public class Ftambah_pelanggan extends JDialog {
    public JButton Bsimpan;    public JButton Bkosongkan;
    private db_connection db = retail.db; //hanya alias aja:p agar ga kepanjangan
    public Ftambah_pelanggan(final Window parent) {    //JFrame parent
        this(parent, "");
    }
    public Ftambah_pelanggan(final Window parent, final String barcode_init) {    //JFrame parent
        super( parent, retail.app_name + " - Tambah Pelanggan" + "   ::   Petugas: " + retail.nama, Dialog.ModalityType.APPLICATION_MODAL);
        final String modul = "Tambah Data Pelanggan";
        String err_msg = "";
        setIconImage(retail.icon_app);
        setMinimumSize( new Dimension(850, 650) );

        final JPanel panel = new JPanel();
	panel.setLayout(null);
        panel.setBorder( BorderFactory.createCompoundBorder( new EmptyBorder(26, 16, 65, 16), BorderFactory.createTitledBorder( BorderFactory.createEtchedBorder(), "Tambah Pelanggan" ) ) );

        JLabel Lname = new JLabel("Nama Pelanggan", JLabel.RIGHT);
        Lname.setBounds(85, 80, 100, 35);  panel.add(Lname);
        final JTextField Tname = new JTextField(50);
        Tname.setBounds( 15 + panel.getComponent(0).getX() + panel.getComponent(0).getWidth(), panel.getComponent(0).getY()+3, 200, 29 );  panel.add(Tname);

        JLabel Lcode = new JLabel("Kode Pelanggan", JLabel.RIGHT);  panel.add(Lcode);
        final JTextField Tcode = new JTextField(20);  panel.add(Tcode);    Tcode.setName("barcode target");    //utk dipakai di event dispatcher agar barcode hanya bisa masuk sini.
        Tcode.setText(barcode_init);    //initial value from caller

        JLabel Lkontak = new JLabel("Kontak", JLabel.RIGHT);  panel.add(Lkontak);
        final JTextField Tkontak = new JTextField(30);  panel.add(Tkontak);

        JLabel Lno_hp = new JLabel("No. HP", JLabel.RIGHT);  panel.add(Lno_hp);
        final JTextField Tno_hp = new JTextField(50);  panel.add(Tno_hp);

        JLabel Lno_telp = new JLabel("No. Telp.", JLabel.RIGHT);  panel.add(Lno_telp);
        final JTextField Tno_telp = new JTextField(50);  panel.add(Tno_telp);

        JLabel Lkota = new JLabel("Kota", JLabel.RIGHT);  panel.add(Lkota);
        final JTextField Tkota = new JTextField(127);  panel.add(Tkota);

        JLabel Lalamat = new JLabel("Alamat", JLabel.RIGHT);  panel.add(Lalamat);
        final JTextField Talamat = new JTextField(127);  panel.add(Talamat);

        JLabel Ldiskon = new JLabel("Diskon", JLabel.RIGHT);  panel.add(Ldiskon);
        final JTextField Tdiskon = new JTextField(2);  panel.add(Tdiskon);

        final JBkeluar Bkeluar = new JBkeluar(this);

        Bkosongkan = new JButton("F5 - kosongkan", retail.icon_reset);
        Bkosongkan.setAlignmentX( Bkeluar.getAlignmentX() );
        Bkosongkan.setIconTextGap( Bkeluar.getIconTextGap() );
        Bkosongkan.setBounds( Bkeluar.getX()-Bkeluar.getWidth()-10-30, Bkeluar.getY(), Bkeluar.getWidth()+30, Bkeluar.getHeight() );//java default
        Bkosongkan.setMnemonic('O');  Bkosongkan.addFocusListener(retail.onHover);
        Bkosongkan.setEnabled(false);

        Bsimpan = new JButton("F10 - simpan", retail.icon_save );
        Bsimpan.setAlignmentX( Bkosongkan.getAlignmentX() );
        Bsimpan.setIconTextGap( Bkosongkan.getIconTextGap() );
        Bsimpan.setBounds( Bkosongkan.getX()-Bkosongkan.getWidth(), Bkosongkan.getY(), Bkosongkan.getWidth()-10, Bkosongkan.getHeight() );//java default
        Bsimpan.setMnemonic('S');  Bsimpan.addFocusListener(retail.onHover);
        Bsimpan.setEnabled(false);

        panel.add(Bsimpan);
        panel.add(Bkosongkan);
        panel.add(Bkeluar);

        getContentPane().add(panel);
        pack();
        setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setResizable(false);
        setLocationRelativeTo(null);

        int ci=0;   String filter_pre;
        for( Component comp : panel.getComponents() ) {
            if( comp instanceof JTextField ) {
                JTextComponent tc = (JTextComponent)comp;
                AbstractDocument doc = (AbstractDocument) tc.getDocument();
                doc.putProperty("tombol_to_enable", new JButton[]{Bsimpan, Bkosongkan} );
                if( comp==Tdiskon ) filter_pre = "\\d{0,";   //"\\d{1," >> dia lakukan validasi klo disetText("") atau setText(null) dari code
                else                filter_pre = ".{0,";    //\\w{0, >> A word character: [\p{Alpha}\p{gc=Mn}\p{gc=Me}\p{gc=Mc}\p{Digit}\p{gc=Pc}]
                doc.setDocumentFilter(new PatternFilter( filter_pre + (int)((JTextField)comp).getColumns() + "}" ));
                doc.addDocumentListener(retail.enable_on_change);
                tc.setMargin( new Insets( 0, 7, 0, 0 ) );
            }
            if( comp instanceof JLabel || comp instanceof JTextField ) {
                ci = panel.getComponentZOrder(comp);
                if( ci>=2 ) comp.setBounds( panel.getComponent(ci-2).getX(), panel.getComponent(ci-2).getY()+40, panel.getComponent(ci-2).getWidth(), panel.getComponent(ci-2).getHeight() );
                if( comp instanceof JLabel ) { //set agar field dapat requestfocus saat labelnya diakses via "mnemonic" key...
                    JLabel label = (JLabel)comp;
                    label.setLabelFor( panel.getComponent(ci+1) );
                         if( label==Lcode    ) label.setDisplayedMnemonic( 'E' );
                    else if( label==Lkontak  ) label.setDisplayedMnemonic( 'N' );
                    else if( label==Lno_hp   ) label.setDisplayedMnemonic( 'H' );
                    else if( label==Lno_telp ) label.setDisplayedMnemonic( 'P' );
                    else if( label==Lkota    ) label.setDisplayedMnemonic( 'T' );
                    else                       label.setDisplayedMnemonic( label.getText().charAt(0) );
                }
            }
        }

        //customize size ...
        Tname.setSize( new Dimension(300, Tname.getHeight()) );
        Tcode.setSize( new Dimension(130, Tname.getHeight()) );
        Talamat.setSize( new Dimension(500, Tname.getHeight()) );
        Tdiskon.setSize( new Dimension(40, Tname.getHeight()) );
        JLabel Ldiskon_persen = new JLabel("%      (untuk dipakai dalam transaksi penjualan)");  Ldiskon_persen.setBounds( Tdiskon.getX() + Tdiskon.getWidth(), Tdiskon.getY(), 350, Tdiskon.getHeight() );  panel.add(Ldiskon_persen);

        Bsimpan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
            if( retail.empty( new JTextComponent[]{ Tcode, Tname } )) return;

            String sql = " INSERT INTO pelanggan (            id      , code, name, kontak, no_hp, no_telp, kota, alamat, diskon ) "
                       + " SELECT             IFNULL( MAX(id), 0) + 1,   ? ,   ?  ,   ?  ,   ?  ,     ?  ,   ? ,     ?  ,    ?    FROM pelanggan" ;
            String[] params = { Tcode.getText(), Tname.getText(), Tkontak.getText(), Tno_hp.getText(), Tno_telp.getText(), Tkota.getText(), Talamat.getText(), Tdiskon.getText() };
            db.exec(sql, params, true);
            if( db.err_msg.equals("") ) {
                Bkosongkan.doClick();
                if( !barcode_init.isEmpty() ) Bkeluar.doClick();    //langsung keluar klo ada barcode_init heeh heee
            } else JOptionPane.showMessageDialog( Ftambah_pelanggan.this, db.err_msg, modul + " Gagal", JOptionPane.ERROR_MESSAGE);
        }});

        Bkosongkan.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) {
                for(Component comp : panel.getComponents())
                    if( comp instanceof JTextField ) ((JTextComponent)comp).setText("");
                Bkosongkan.setEnabled(false);    Bsimpan.setEnabled(false);
                Tname.requestFocus();
        }});

        ActionListener onClose = new ActionListener() { public void actionPerformed(ActionEvent e) {
                if( !Bsimpan.isEnabled() ) { close(); return; }
                int resp = JOptionPane.showOptionDialog( retail.f, "\nPerubahan data ingin disimpan?\n\n\n\n", "Konfirmasi", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, retail.icon_confirm, retail.Boptions, null);
                if( resp==0 ) { //"YA"
                    Bsimpan.doClick();
                    if( !Bsimpan.isEnabled() ) close();
                } else if( resp==1 ) { //"TIDAK"
                    close();
                }
        }};
        Bkeluar.addActionListener(onClose);
        addWindowListener(new WindowAdapter() {  @Override public void windowClosing(WindowEvent e) {
                Bkeluar.doClick();
        }});

        retail.removeTitleButtons(this, onClose);
        retail.addEnterToTraversalKeys(this);

        setVisible(true);
    }
    void close() {
        db.close(); dispose();
    }
}