/*
 * %W% %E%
 * 
 * Copyright (c) 2006, Oracle and/or its affiliates. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * -Redistribution of source code must retain the above copyright notice, this
 *  list of conditions and the following disclaimer.
 * 
 * -Redistribution in binary form must reproduce the above copyright notice, 
 *  this list of conditions and the following disclaimer in the documentation
 *  and/or other materials provided with the distribution.
 * 
 * Neither the name of Oracle or the names of contributors may 
 * be used to endorse or promote products derived from this software without 
 * specific prior written permission.
 * 
 * This software is provided "AS IS," without a warranty of any kind. ALL 
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING
 * ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
 * OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN MICROSYSTEMS, INC. ("SUN")
 * AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE
 * AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
 * DERIVATIVES. IN NO EVENT WILL SUN OR ITS LICENSORS BE LIABLE FOR ANY LOST 
 * REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, 
 * INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY 
 * OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, 
 * EVEN IF SUN HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * 
 * You acknowledge that this software is not designed, licensed or intended
 * for use in the design, construction, operation or maintenance of any
 * nuclear facility.
 */

/*
 * %W% %E%
 */

/**
 * Part: The TableModel adaptor (transforming the JDBC interface to the TableModel interface).
 *
 * @version 1.20 09/25/97
 * @author Philip Milne
 */

/**
 * Part: others of above ...
 *
 * @version 1.0 06/17/2014
 * @author Rafik, http://solusiprogram.com/
 */


package retail_base;

import java.sql.*;
import javax.sql.*;
import javax.sql.rowset.*;
//import com.sun.rowset.*;

import java.io.File;
import java.io.FileReader;
//import java.io.IOException;
//import java.io.FileNotFoundException;
import java.io.BufferedReader;
import javax.swing.JOptionPane;
import java.util.*;
 
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;

//import java.util.Vector;
//FYI, use of Vector is mostly discouraged nowadays. You should probably prefer ArrayList.  
//as it doesn't have the overhead of having synchronized methods. You could use
//List<String> list = new ArrayList<String>(Arrays.asList(array));

//ArrayList<Integer> al = new ArrayList<Integer>(); 
//for( int i = 0; i< a.length; i++ ) { 
//al.add( new Integer( a[ i ] ); 
//}
import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;
import javax.swing.event.TableModelEvent; 

import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.JComponent;
import javax.swing.JComboBox;

//import java.lang.reflect.Field;
//import java.lang.reflect.Modifier;


public class db_connection extends AbstractTableModel /*implements javax.swing.table.TableRowSorter.ModelWrapper */ {

/*
Modifier 	Class 	Package Subclass World
public 		Y 	Y 	Y 	Y
protected 	Y 	Y 	Y 	N
no modifier 	Y 	Y 	N 	N
private 	Y 	N 	N 	N

final: tidak bisa diubah oleh subclass
static: bisa diakses sebagai elemen class, tidak harus object.
*/
    Connection con = null;
    Statement cmd = null;
    PreparedStatement cmdp = null;
    ResultSet rs_temp = null;
    CachedRowSet rs = null; //utk menyimpan hasil SELECT
    int affected = -1; //utk menyimpan hasil UPDATE atau INSERT
    int last_inserted_id;

    String[]             columnNames = {};
    ArrayList<ArrayList> rows = new ArrayList<ArrayList>();    //perlu diinitiate agar (at least) rows.size() di getRowCount tidak return null :p
    ResultSetMetaData    metaData;

    TableColumnModel     column_model;
    JComponent[]         col_editor = {};
    int[]                col_width = {};

    //for the no db metaData:)
    String[]             col_label = {};
    int[]                col_type = {};
    int[]                col_precision = {};

    String last_sql = "";    String last_sql_read = "";
    String err_msg = "";
    String table_name = "";
    Boolean[] isSigned = {};

    private static String IV = "rafikoi@yahoocom";
    protected String encryptionKey = "harus16digit:ppp";    //private static String encryptionKey = "was rafikoi@yahoo.com";

    public db_connection(/*JComponent parent*/) {
        read_cfg(); //ditaruh di sini memang ada resiko gak uptodate kecuali program ditutup :)
        //Class.forName("com.mysql.jdbc.Driver");
    }

    //String dbUrl = ""; //"jdbc:mysql://localhost:3306/retail";
    Map<String, String> cfg = new HashMap<String, String>() {{ //java does not support associative arrays :p
        put( "database"                 , "" );
        put( "user"                     , "" );
        put( "password"                 , "" );
        put( "host"                     , "" );
        put( "socket"                   , "" );
        put( "dbms"                     , "" );
        put( "user_login_default"       , "" );
        put( "password_login_default"   , "" );
        put( "pembulatan_rupiah"        , "100" );
        put( "barcode_delay"            , "100" );
        put( "direktori_gambar"         , "img/file_gambar/" );
        put( "filename"                 , "konfigurasi.txt" );
        put( "aktifkan_suara"           , "ya" );
        put( "ppn_aktif_secara_default" , "tidak" );
        put( "ppn_ditampilkan"          , "ya" );
    }};

    protected void read_cfg() {
        File file = new File( cfg.get("filename") );
        if( !file.exists() ) {
            try {
                JOptionPane.showMessageDialog( retail.f, "File Konfigurasi \"" +file.getCanonicalPath()+ "\" tidak ditemukan!\nMohon klik tombol \"Setting\"", "Konfigurasi File", JOptionPane.ERROR_MESSAGE );
                //ga ngaruh >> JOptionPane.showMessageDialog(retail.f, "File Konfigurasi \"" +file.getCanonicalPath()+ "\" tidak ditemukan!\nMohon klik tombol \"Database\"", "Konfigurasi File", JOptionPane.ERROR_MESSAGE, retail.icon_exit );
            } catch (Exception e) {}
            return;
        }
        String line = null;
        int pos;
        String var   = "";
        String value = "";
        try {
            BufferedReader br = new BufferedReader( new FileReader(file) );
            while ((line = br.readLine()) != null) {
                line = line.trim();    //.replaceAll("[ \x0B\f\r]","")
                //escape character
                if( line.indexOf("//") == 0 ) continue;
                if( line.indexOf("#" ) == 0 ) continue;
                //trim right escape character hanya jika ada spasi di depannya:p, otherwise, ia bagian dari data
                pos = line.indexOf(" //"); if( pos >= 0 ) line = line.substring(0, pos).trim();
                pos = line.indexOf(" #" ); if( pos >= 0 ) line = line.substring(0, pos).trim();

                pos = line.indexOf(":"); //the data delimiter
                if( pos <= 0 ) continue;
                var   = line.substring(0, pos).trim().toLowerCase().replace(" ","_");//get the identifier found on the left
                value = line.substring(pos+1,line.length()).trim();  //ini sama tapi biar umum aja sama dgn other languages:D >> line.substring(pos+1).trim();
                if( var.indexOf("password")>=0 ) value = value.substring(1,value.length()-1);  //enclosed with '"' agar tab ga ketrim :p

                //?? tp ini ga bisa utk deteksi hak akses customer terhadap fitur ppn krn read_cfg tuh sebelum baca db:p >> if( retail.hak_fitur???.indexOf("'blabla'") >= 0 ) {

                cfg.put( var, value );   //switch(var) //(only) In the JDK 7 release, you can use a String object in the expression of a switch statement:
            }
            br.close();
        } catch (Exception e) {
            err_msg += "Pembacaan File '" +cfg.get("filename")+ "' Gagal!\n" + e.getMessage() ;
        //} finally { br.close();
        }
    }

    protected void open() {
        //read_cfg();
        try {
            if( con == null || con.isClosed() ) {
                //con = DriverManager.getConnection (dbUrl, user, password);  //con.Open();
                con = DriverManager.getConnection( "jdbc:" +cfg.get("dbms")+ "://" +cfg.get("host")+ ":" +cfg.get("socket")+ "/" +cfg.get("database") + "?jdbcCompliantTruncation=false&user=" +cfg.get("user")+ "&password=" +decrypt( cfg.get("password"), encryptionKey ) );  //    //tanpa jdbcCompliantTruncation=false ... muncul warning truncate dari db saat integer diisi "":p
            }
        } catch (Exception e) {
            err_msg += "Koneksi ke Database Gagal!\n";
            if( e.getMessage().indexOf("Access denied") >= 0) err_msg += "Mohon klik tombol \"Setting\" dan lakukan \"Test Koneksi\"!\n\n\n";
            else                                              err_msg += "Pastikan server database sudah dijalankan!\n\n\n";
            //err_msg += e;
            if( con != null) close(); //if( !con.isClosed() ) con.close();  // dispose the connection to avoid connections leak
        }
    }

    public void exec( String sql, String[] parameters, Boolean keep_open, Boolean to_table ) {
        err_msg = ""; //need to reset
        //gak perlu:p Justru cmdp sebaiknya live >> cmd = null; cmdp = null;
        open();

        if( !last_sql.equals(sql) )
            try {
                    sql = sql.replace("  "," ");    //biar ngirit karakter yg dikirim ke server ... haha
                    if( parameters == null                                   ) cmd  = con.createStatement();
                    else if( sql.trim().toUpperCase().indexOf("INSERT") == 0 ) cmdp = con.prepareStatement(sql, Statement.RETURN_GENERATED_KEYS); //ini jg bisa: con.prepareStatement(sql, new String[]{"id"});  //to get last inserted id
                    else                                                       cmdp = con.prepareStatement(sql);

                /* ribet bgt idup gue :)
                //if( ( cmd==null || cmd.isClosed() ) && ( cmdp==null || cmdp.isClosed() ) ) {   //if( cmd==null && cmdp==null )    //if( !last_sql_read.equals(sql) ) tadinya si last_sql_read utk ngecek apakah cmd isclosed ... tapi sekarang gue pakai untuk refresh read:)
                    if( parameters == null                                   && (cmd ==null || cmd.isClosed())  ) cmd  = con.createStatement();
                    else if( sql.trim().toUpperCase().indexOf("INSERT") == 0 && (cmdp==null || cmdp.isClosed()) ) cmdp = con.prepareStatement(sql, Statement.RETURN_GENERATED_KEYS); //ini jg bisa: con.prepareStatement(sql, new String[]{"id"});  //to get last inserted id
                    else                                                     if( cmdp==null || cmdp.isClosed()  ) cmdp = con.prepareStatement(sql);
                //}
                */
            } catch (Exception e) {
            }

        last_sql = sql;

        if( sql.trim().toUpperCase().indexOf("SELECT") == 0 ) exec_read  ( sql, parameters, keep_open, to_table );  //hehhee
        else                                                  exec_update( sql, parameters, keep_open );  //hehhee

        if( !keep_open ) close();
    }
    //overload method
    public void exec( String sql) {
        String[] parameters = null; Boolean keep_open = false; Boolean to_table = false;
        exec(sql, parameters, keep_open, to_table);
    }
    //overload method
    public void exec( String sql, String[] parameters) {
        Boolean keep_open = false; Boolean to_table = false;
        exec(sql, parameters, keep_open, to_table);
    }
    //overload method
    public void exec( String sql, String[] parameters, Boolean keep_open ) {
        Boolean to_table = false;
        exec(sql, parameters, keep_open, to_table);
    }

    public void exec_read( String sql, String[] parameters, Boolean keep_open, Boolean to_table ) {
        ResultSet rs_temp = null;
        rs = null;
        if( err_msg != "" ) return;

        try {
            //crs = new CachedRowSetImpl();      //warning: CachedRowSetImpl is internal proprietary API and may be removed in a future release
            // Create the class with class.forName to avoid importing from the unsupported com.sun packages.
            Class c = Class.forName( "com.sun.rowset.CachedRowSetImpl" );
            rs = (CachedRowSet) c.newInstance();

            //RowSetFactory rowSetFactory = RowSetProvider.newFactory();
            //CachedRowSet crs = rowSetFactory.createCachedRowSetImpl();

            if (parameters == null) {
                rs_temp = cmd.executeQuery(sql);
            } else {
                for (int i = 0; i < parameters.length; i++) cmdp.setString( i+1, parameters[i].trim() );
                rs_temp = cmdp.executeQuery();
            }
            rs.populate(rs_temp);  rs_temp.close();  rs_temp = null;
            if( !keep_open ) close();   //frees connection resources

            if(to_table) show_table(rs, rs.size()==0 && col_type!=null && col_type.length>0 && col_type[0]!=0 );    //untested parameter kedua, gunanya agar tidak error saat view table kosong    //prepare data for viewing table
            last_sql_read = sql;    //utk direfresh:) sehingga form2 ga perlu menconstruct ulang sql lagi.
        } catch (Exception e) {
              err_msg += "\nData Gagal Dibaca!\n"
                      +  "\nPesan Error: " + e//.getMessage()
                      +  "\nSQL: " + sql
                      ;
        }
    }

    public void show_table( CachedRowSet crs ) {
        show_table( crs, true );
    }
    public void show_table( CachedRowSet crs, Boolean init_new_row ) {
        //if( err_msg != "" ) return;
        try {
            int numberOfColumns = col_width.length;    //metaData.getColumnCount();

            if( crs!=null ) metaData = crs.getMetaData();       //RowSetMetaData rsmd = (RowSetMetaData)crs.getMetaData();
            else { //don't contact the db, just create my own RowSetMetaData:)
                RowSetMetaData md = new RowSetMetaDataImpl();
                md.setColumnCount( numberOfColumns );
                for( int i=0; i<numberOfColumns; i++ ) {
                    md.setColumnName (i+1, col_label[i]);
                    md.setColumnLabel(i+1, col_label[i]);
                    md.setColumnType (i+1, col_type[i]);
                    md.setTableName  (i+1, "no_db");
                    md.setPrecision  (i+1, col_precision[i]);
                    md.setSigned     (i+1, false);
                }
                metaData = (ResultSetMetaData) md;
            }

            table_name = metaData.getTableName(1);    //supaya ga harus pake try{} mulu...

            columnNames = new String[numberOfColumns];  //set column label
            isSigned    = new Boolean[numberOfColumns];  //set column isSigned. Supaya ga harus pake try{} mulu...
            for( int i=0; i<numberOfColumns; i++ ) {
                columnNames[i] = metaData.getColumnLabel(i+1);
                isSigned[i]    = metaData.isSigned(i+1);
            }

            rows = new ArrayList<ArrayList>();
            if( crs==null || crs.size()==0 && init_new_row ) {    //jika crs.size()==0 && !init_new_row, ini berarti lupa ngeset col_type, jadi biar masuk ke else
                if(init_new_row) addRow();  // just add new blank row
            } else {                        // Get all rows.
                Object[] rs_row = new Object[numberOfColumns];
                col_type        = new int[numberOfColumns];
                while( crs.next() ) {
                    for( int i=0; i<numberOfColumns; i++ ) {  //klo ga gini, kebanyakan try{} ntar
                        rs_row[i] = crs.getObject(i+1);
                        if(col_type[i]==0) col_type[i] = metaData.getColumnType(i+1);
                    }
                    addRow(rs_row,col_type);
                }
            }
            fireTableChanged(null); // Tell the listeners a new table has arrived.

            TableColumn column;
            //Set column width, and editor
            int shift=0;
            for( int i=0; i<numberOfColumns; i++ ) {
                column = column_model.getColumn(i+shift);
                if( col_width[i] == 0 ) {                                     //There is also the way about the TableCellRenderer. But you may ask about this, if this solution does won't work.
                    column_model.removeColumn(column);    //ato ini? table.removeColumn(table.getColumnModel().getColumn(i)); // REMOVE   //ga sah pake cellEditor.shouldSelectCell :D    //ini masih traverse :( >>  //column.setMinWidth(0);    //column.setMaxWidth(0);
                    //tapi hrs convertRowIndex setelah sort, sehingga utk ngambil valuenya, kudu `table.getModel().getValueAt(table.convertRowIndexToModel(row), 4) .... which i did kayaknya
                    // dan hrs selalu pake table.getModel().getValueAt() dan table.getModel().setValueAt() which i did:)
                    shift--;
                } else {
                    column.setPreferredWidth( Math.abs(col_width[i]) );  //incomparable types:( >> if( col_width[i] != null )

                    if( col_width[i] > 0 ) //otherwise jika negatif, berarti non editable:p    //another alternatif (but not preferred by me:)) as TableFTFEditDemo.java >> table.setDefaultEditor(Integer.class, new IntegerEditor(0, 100));
                                                              //            JOptionPane.showMessageDialog( retail.f, "ggg " + columnNames[i] +col_editor[i].getClass().getName() + (col_editor[i]==null), "Kesalahan", JOptionPane.ERROR_MESSAGE);
                             //if( !(col_editor[i] instanceof JCdb) ) column.setCellEditor(new filtered_text_CellEditor( get_column_pattern(i) ));
                             if( col_editor[i]==null ) column.setCellEditor(new filtered_text_CellEditor( get_column_pattern(i) ));
                             //if( col_editor[i].getClass()==null ) column.setCellEditor(new filtered_text_CellEditor( get_column_pattern(i) ));
                        else if( err_msg.equals("")  ) column.setCellEditor(new combo_db_CellEditor( (JComboBox)col_editor[i] ));

                    if( col_editor[i]!=null && col_editor[i]==retail.Cname_brg )                            column.setCellRenderer( retail.right_align_renderer );    //&& i==1   //(kayaknya beresiko klo dibatalin return Stringnya) name barang kayaknya bagus rata kanan deh...
                    else if( col_editor[i]==null )    //this take my 3 hours :( ... the error does not raise ... just form not showing apparently :p
                        if( col_type[i]==Types.INTEGER || col_type[i]==Types.SMALLINT )                     column.setCellRenderer( retail.number_renderer );
                        else if( columnNames[i].indexOf("diskon")>=0 || columnNames[i].indexOf("disc")>=0 ) column.setCellRenderer( retail.percent_renderer );
                }

                //di getColumnName ajah ... if( columnNames[i].indexOf("__")>=0 ) column.setHeaderValue( "<html><center>" + getColumnName(i).replace("  ","<br>") );    //columnNames[i].replace("__","\\n")
                                             //column.setHeaderRenderer( retail.header_wrap_renderer );
                                             /*
                                             javax.swing.table.TableCellRenderer header_renderer = column.getHeaderRenderer();
                                             Component rendererComponent = header_renderer.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
                                             header_renderer.setText( "ss" );
                                             column.setHeaderRenderer( header_renderer );
                                             */

            }
            //bikin getColumn(i) gagal >> fireTableChanged(null);
        } catch (Exception e) {
              err_msg += "\nProses penampilan tabel gagal!\n"
                      +  "\nPesan Error: " + e//.getMessage()
                      ;
        }
    }

    public void exec_update( String sql, String[] parameters, Boolean keep_open ) {
        affected = 0;
        if( err_msg != "" ) return;
        try {
            if( parameters == null ) {
                if( sql.indexOf(";\n") > 0 ) {    //execute batch sql
                    for( String sqlb : sql.split(";\n") ) if( !sqlb.trim().equals("") ) cmd.addBatch(sqlb);
                    int[] returnb = cmd.executeBatch();    //hati2 .. dia tetap lanjut walau error :p :)   //anyway, ini tetap tidak atomic:) unless u apply START TRANSACTION with innodb
                    affected = returnb[ returnb.length-1 ];
                    //for (int code : returnb) err_msg += code + ", batch   ";
                    //static int EXECUTE_FAILED >> The constant indicating that an error occured while executing a batch statement.
                } else
                    affected = cmd.executeUpdate(sql);
            } else {
                Boolean insert_query = sql.trim().toUpperCase().indexOf("INSERT") == 0 ;
                for (int i = 0; i < parameters.length; i++) {  //if (parameters[i] == "NULL") cmd.Parameters.Add(new SqlParameter("@param" + (i + 1), DBNull.Value)); else 
                    if( insert_query && retail.is_number( parameters[i] ) ) parameters[i] = parameters[i].replace( retail.digit_separator, "" );    //bonus untuk Ftambah:)    //if( col_type[i]==Types.INTEGER || col_type[i]==Types.SMALLINT || col_type[i]==Types.BIGINT )
                    cmdp.setString( i+1, parameters[i].trim() ); //cmd.Parameters.Add(new SqlParameter("@param" + (i + 1), parameters[i].Trim().Replace("\n", " "))); //Replace is for text area //Replace("\r", "").Replace("\n", "<br/>")
                }
                affected = cmdp.executeUpdate();
                if(insert_query) {    //get last inserted id
                    last_inserted_id = -100;
                    ResultSet keys = cmdp.getGeneratedKeys();
                    if( keys.next() ) last_inserted_id = keys.getInt(1);    //if( keys.getFetchSize()>0 )
                    //from mysql manual: For the benefit of some ODBC applications (at least Delphi and Access), the following query can be used to find a newly inserted row:
                    //SELECT * FROM tbl_name WHERE autoincrement_column IS NULL;
                    //and this maybe useful: LAST_INSERT_ID() now returns 0 if the last INSERT statement didn't insert any rows.
                }
            }
                                                           //supaya tidak muncul pesan error "tidak ada data yg bisa diupdate" saat ALTER TABLE jual_faktur AUTO_INCREMENT sebelumnya sudah benar :D
            if( affected <= 0 && sql.toUpperCase().indexOf("ALTER TABLE ") < 0 ) err_msg += "\nMaaf, tidak ada data yang bisa diupdate!\n\n\n\n\n";

            String table_name = sql.toLowerCase().indexOf("into barang ") >= 0 ? "barang" : sql.toLowerCase().indexOf("into pelanggan ") >= 0 ? "pelanggan" : sql.toLowerCase().indexOf("into supplier ") >= 0 ? "supplier" : "" ;
            if( table_name.isEmpty() ) table_name = sql.toLowerCase().indexOf("update barang ") >= 0 && sql.toLowerCase().indexOf("set stok") < 0 ? "barang" : sql.toLowerCase().indexOf("update pelanggan ") >= 0 && sql.toLowerCase().indexOf("set poin") < 0? "pelanggan" : sql.toLowerCase().indexOf("update supplier ") >= 0 ? "supplier" : "" ;
            if( !table_name.isEmpty() && retail.setting.get("Auto Refresh Delay Item & Barang Di Transaksi") != null ) {
                Boolean cmd_is_null = cmd==null || cmd.isClosed();
                if( cmd_is_null ) cmd  = con.createStatement();
                cmd.executeUpdate( "REPLACE INTO last_modified (table_name) VALUES ('" +table_name+ "')" );
                if( cmd_is_null ) cmd.close();
            }
        } catch( Exception e ) {
            if( e.getMessage().indexOf("Duplicate entry") >= 0) err_msg += "\nMaaf, ada duplikasi data!\nIsian " + e.getMessage().substring( e.getMessage().indexOf("'"), e.getMessage().lastIndexOf("'")+1 ) + " sudah ada.\nMohon perbaiki isian Saudara!\n\n\n\n\n";
            else                                                err_msg += "\nMaaf, data gagal diupdate!\nPesan kesalahan: " + e.getMessage() + ".\nTolong Hubungi Administrator!\n\n\n\n\n";
        }
        //if( affected <= 0 ) err_msg += "\nMaaf, Tidak ada data yang bisa diupdate!\n\n\n\n\n";
    }

    protected void close( Boolean rs_close ) {
        try {
            //eh, jgn dengg:p >>> err_msg  = "";  //not thoroughly check yet:)
            last_sql = "";
            //last_sql_read = "";    //masih gue pakai saat refresh
            //err_msg += "debug: " + this.rs.size(); //while (rs.next()) { err_msg += "\nData : " + rs.getString(1); }
            if( rs_close ) if( rs != null ) rs.close();
            if( cmd != null) cmd.close();
            if( cmdp != null) cmdp.close();
            if( con != null) con.close();        //if( !con.isClosed() ) ;
        } catch (Exception e) {
            err_msg += "\nMaaf, Koneksi ke Database Gagal Ditutup!\n(" + e.getMessage() + ")";
        }
    }
    protected void close() {    //overload method, ga perlu rs_close
        close(false);
    }



  //encrypt doang take my whole day:( ... tau gitu mending diencode manual ajah :p
/* well, alternatively, java 8 !!! or .... 
import org.apache.commons.codec.binary.Base64;
    byte[] encodedBytes = Base64.encodeBase64("JavaTips.net".getBytes());
    System.out.println("encodedBytes " + new String(encodedBytes));
    byte[] decodedBytes = Base64.decodeBase64(encodedBytes);
    System.out.println("decodedBytes " + new String(decodedBytes));
*/

  //static byte[] encrypt(String plainText, String encryptionKey) throws Exception {
  String encrypt(char[] plainText, String encryptionKey) throws Exception {
    Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5PADDING");
    //Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding", "SunJCE");
    SecretKeySpec key = new SecretKeySpec(encryptionKey.getBytes("UTF-8"), "AES");
    cipher.init(Cipher.ENCRYPT_MODE, key,new IvParameterSpec(IV.getBytes("UTF-8")));
    String newText = new String(plainText).trim();
    //for (int i = plainText.length; i < 16; i++) newText += " "; //padding:p

    //Class c = Class.forName( "sun.misc.BASE64Encoder" );
    //sun.misc.BASE64Encoder encoder = (sun.misc.BASE64Encoder) c.newInstance();
    return new sun.misc.BASE64Encoder().encodeBuffer( cipher.doFinal(newText.getBytes("UTF-8")) );
    //return URLEncoder.encode( new String( cipher.doFinal(newText.getBytes("UTF-8")), "UTF-8" ), "UTF-8" );
    //return new String( cipher.doFinal(newText.getBytes("UTF-8")), "UTF-8");

    //return Base64.encodeBase64String( cipher.doFinal(newText.getBytes("UTF-8")) );
    //return new String( cipher.doFinal(newText.getBytes("UTF-8")) );
    //return cipher.doFinal(newText.getBytes("UTF-8"));
    //return cipher.doFinal(plainText.getBytes("UTF-8"));
  }
 
  String decrypt(String cipherText, String encryptionKey) throws Exception{
  //private static String decrypt(byte[] cipherText, String encryptionKey) throws Exception{
    Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5PADDING");
    //Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding", "SunJCE");  //AES/CBC/NoPadding
    SecretKeySpec key = new SecretKeySpec(encryptionKey.getBytes("UTF-8"), "AES");
    cipher.init(Cipher.DECRYPT_MODE, key,new IvParameterSpec(IV.getBytes("UTF-8")));
    //byte[] newText = new byte[cipherText.length()];
    //for (int i = 0; i < cipherText.length(); i++) newText[i] = (byte)(cipherText.charAt(i));   //new byte(cipherText[i]);
                
    //Class c = Class.forName( "sun.misc.BASE64Decoder" );
    //sun.misc.BASE64Decoder decoder = (sun.misc.BASE64Decoder) c.newInstance();
    return new String(cipher.doFinal( new sun.misc.BASE64Decoder().decodeBuffer(cipherText)));
    //return new String( cipher.doFinal( URLDecoder.decode(cipherText, "UTF-8").getBytes("UTF-8")), "UTF-8");
    //return new String( cipher.doFinal( cipherText.getBytes("UTF-8") ), "UTF-8").trim();

//    return new String(cipher.doFinal(newText),"UTF-8").trim();

    //return new String(cipher.doFinal(Base64.decodeBase64(cipherText))).trim();
    //return new String(cipher.doFinal(cipherText.getBytes("UTF-8")),"UTF-8").trim();
    //return new String(cipher.doFinal(cipherText),"UTF-8");

  }




/*

Using the javascript engine that is shipped with Java 6:


import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;

public class Wow
{
    public static void main(String[] args) throws Exception
    {
        ScriptEngineManager factory = new ScriptEngineManager();
        ScriptEngine engine = factory.getEngineByName("JavaScript");
        engine.eval("print(encodeURIComponent('\"A\" B  \"'))");
    }
}





//var key = "SXGWLZPDOKFIVUHJYTQBNMACERxswgzldpkoifuvjhtybqmncare";
  var key = "SXG0W46LZP7DOKFI1VU3H2JYT-QBNMACE5_Rxs*wgzl8dpkoifuvjh9tybqmncare";
// matches abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-*

function encodeStr(uncoded) {
  uncoded = uncoded.trim(); //replace(/^\s+|\s+$/g,"");
  var coded = "";
  var chr;
  for( var i = uncoded.length-1; i>=0; i-- ) {
    chr = uncoded.charCodeAt(i);
    coded += (chr >= 65 && chr <= 90) ? 
      key.charAt( chr - 65 + 26*Math.floor(Math.random()*2) ) :
      String.fromCharCode(chr); 
    }
  return encodeURIComponent(coded);  
  }

function decodeStr(coded) {
  coded = decodeURIComponent(coded);  
  var uncoded = "";
  var chr;
  for (var i = coded.length - 1; i >= 0; i--) {
    chr = coded.charAt(i);
    uncoded += (chr >= "a" && chr <= "z" || chr >= "A" && chr <= "Z") ?
      String.fromCharCode(65 + key.indexOf(chr) % 26) :
      chr; 
    }
  return uncoded;   
  } 


import java.security.MessageDigest;

..

byte[] bytesOfMessage = yourString.getBytes("UTF-8");

MessageDigest md = MessageDigest.getInstance("MD5");
byte[] thedigest = md.digest(bytesOfMessage);



String plaintext = "your text here";
MessageDigest m = MessageDigest.getInstance("MD5");
m.update(plaintext.getBytes());
byte[] digest = m.digest();
BigInteger bigInt = new BigInteger(1,digest);
String hashtext = bigInt.toString(16);
// Now we need to zero pad it if you actually want the full 32 chars.
while(hashtext.length() < 32 ){
  hashtext = "0"+hashtext;
}

  public byte[] hash(String param_pwd)
  {
    //Hash the password
    MD5CryptoServiceProvider md5Hasher = new MD5CryptoServiceProvider();
    UTF8Encoding encoder = new UTF8Encoding();
    byte[] hashedDataBytes = md5Hasher.ComputeHash(encoder.GetBytes(param_pwd));
    return hashedDataBytes;
  }



Demonstrate simple use of the CachedRowSet

import javax.sql.rowset.CachedRowSet;

// Demonstrate simple use of the CachedRowSet. The RowSet family of interfaces
// is in JDK1.5, but the Implementation classes are (as of Beta 1) still in the
// unsupported "com.sun" package.
//
public class CachedRowSetDemo {
  public static final String ROWSET_IMPL_CLASS = "com.sun.rowset.CachedRowSetImpl";

  public static void main(String[] args) throws Exception {
    CachedRowSet rs;

    // Create the class with class.forName to avoid importing
    // from the unsupported com.sun packages.
    Class c = Class.forName(ROWSET_IMPL_CLASS);
    rs = (CachedRowSet) c.newInstance();

    rs.setUrl("jdbc:postgresql:tmclub");
    rs.setUsername("ian");
    rs.setPassword("secret");

    rs.setCommand("select * from members where name like ?");
    rs.setString(1, "I%");

    // This will cause the RowSet to connect, fetch its data, and
    // disconnect
    rs.execute();

    // Some time later, the client tries to do something.

    // Suppose we want to update data:
    while (rs.next()) {
      if (rs.getInt("id") == 42) {
        rs.setString(1, "Marvin");
        rs.updateRow(); // Normal JDBC

        // This additional call tells the CachedRowSet to connect
        // to its database and send the updated data back.
        rs.acceptChanges();
      }
    }

    // If we're all done...
    rs.close();
  }
}


*/


/* masing2 object beda:p Most of them have toString() methode

public static String spyFields(Object obj) throws IllegalAccessException {
    StringBuffer buffer = new StringBuffer();
    Field[] fields = obj.getClass().getDeclaredFields();
    for (Field f : fields) {
      if (!Modifier.isStatic(f.getModifiers())) {
        f.setAccessible(true);
        Object value = f.get(obj);
        buffer.append(f.getType().getName());
        buffer.append(" ");
        buffer.append(f.getName());
        buffer.append("=");
        buffer.append("" + value);
        buffer.append("\n");
      }
    }
    return buffer.toString();
  }
*/

/*


public String readFile(String filename)
{
   String content = null;
   File file = new File(filename); //for ex foo.txt
   try {
       FileReader reader = new FileReader(file);
       char[] chars = new char[(int) file.length()];
       reader.read(chars);
       content = new String(chars);
       reader.close();
   } catch (IOException e) {
       e.printStackTrace();
   }
   return content;
}
*/

/*especially for binary files...
    FileInputStream inputStream = new FileInputStream("foo.txt");
    try {
        String everything = IOUtils.toString(inputStream);
    } finally {
        inputStream.close();
    }
*/

/*
Scanner sc = new Scanner(new FileReader("filename.txt"));
List<Person> people = new ArrayList<Person>();

            while(sc.hasNextLine()){
                String line = sc.nextLine();
                String[] details = line.split(":");
                String gender = details[0];
                String name = details[1];
                int age = Integer.parseInt(details[2]);
                Person p = new Person(gender, name, age);
                people.add(p);
            }

*/




    //  Implementation of the TableModel Interface

    // MetaData
    public String getColumnName(int column) {
        String col_name = columnNames[column];
        if( col_name==null )            col_name = "";
        else                            col_name = retail.toTitleCase(col_name).replace(" Id", " ").replace("Code", "Kode").replace("Name", "Nama");  //.replace("_", " "); //.toUpperCase()
        if( col_name.indexOf("  ")>=0 ) col_name = "<html><center>" + col_name.replace("  ","<br>");    //di col_label harus ada "__" utk mewakili newline.
        return col_name;
    }

    public Class getColumnClass(int column) {    //ga bisa:  throws SQLException
        if( col_editor[column] != null ) if( col_editor[column] instanceof JCdb ) return String.class;   //supaya tidak right align :p

        switch( col_type[column] ) {
            case Types.CHAR:
            case Types.VARCHAR:
            case Types.LONGVARCHAR:
                return String.class;

            case Types.BIT:
                return Boolean.class;

            case Types.INTEGER:
               if( !isSigned[column] )  return Long.class;    //anyway bakal diset otomatis oleh javanya jg deh ....
            case Types.TINYINT:
            case Types.SMALLINT:
            //none>> case Types.MEDIUMINT:
                return Integer.class;

            case Types.BIGINT:
                return Long.class;

            case Types.FLOAT:
            case Types.DOUBLE:
                return Double.class;

            case Types.DATE:
                return java.sql.Date.class;

            default:
                return Object.class;
        }
    }

    public boolean isCellEditable(int row, int column) {
        try {
            //JOptionPane.showMessageDialog( retail.f, "in celleditable", "Kesalahan", JOptionPane.ERROR_MESSAGE);// Some of the drivers seem buggy, table should not be null.
            return metaData.isWritable(column+1) && col_width[column]>0 ;  //if( table.getModel().getColumnName(column).toLowerCase().equals("id") 
        }
        catch (SQLException e) {
            return false;
        }
    }

    public int getColumnCount() {
        return columnNames.length;
    }

    // Data methods
    public int getRowCount() {
        return rows.size();
    }

/*
    public String getValue(int col_idx, Object val) {
        //if( columnNames[col_idx].toLowerCase().equals("diskon") && value.toString().trim().equals("%") ) value="";
        if( val==null) val="";
        String value = val.toString().trim();
        }
    }
*/

    public Object getValueAt(int row_idx, int col_idx) {
        // method getValueAt ini ternyata dipanggil oleh sorter .... dan error saat firetableinsertedrow selalu gagal krn ga bs casting to integer error gitu dehhh .... hm, ngabisin waktu gue ni seharian ... sekarang da jam 12.24 :(
        //return getValue(col_idx, ((Vector)rows.elementAt(row_idx)).elementAt(col_idx) );
        Object val = ((ArrayList<Object>)rows.get(row_idx)).get(col_idx);    //((Vector)rows.elementAt(row_idx)).elementAt(col_idx);
        if( val==null) val="";
        return val;
    }
    public String to_str(int col_idx, Object val) {
        String value = val.toString().trim();
        if( col_editor[col_idx] instanceof JCdb )   return value;
        //di pattern_Filter aja deh :p  >> if( getColumnName(col_idx).equals("Kode") ) value = retail.ean13(value);
        switch( col_type[col_idx] ) {
            case Types.TINYINT : return value.equals("")?"0":Integer.valueOf(value).toString();
            case Types.INTEGER : return value.equals("")?"0":Integer.valueOf(value).toString();  //((Integer)value).toString();    //(new Integer(value.toString())).toString();    //Integer.valueOf( (Int)value );
            case Types.BIGINT  : return value.equals("")?"0":Integer.valueOf(value).toString();  //((Integer)value).toString();    //(new Integer(value.toString())).toString();    //Integer.valueOf( (Int)value );
            case Types.SMALLINT: return value.equals("")?"0":Integer.valueOf(value).toString();  //((Integer)value).toString();    //(new Integer(value.toString())).toString();    //Integer.valueOf( (Int)value );
            case Types.DOUBLE  : return Double.valueOf(value).toString();  //((Double)value).toString();
            case Types.FLOAT   : return Float.valueOf(value).toString();  //((Float)value).toString();
            case Types.BIT     : return Boolean.valueOf(value).toString();  //((Boolean)value).booleanValue() ? "1" : "0";
            case Types.DATE    : return value; // This will need some conversion.
            default            : return value;
        }

/*
        switch( col_type[col_idx] ) {
            case Types.TINYINT : value = value.replace("%","").trim();    return value.equals("")?"0":Integer.valueOf(value).toString();  //% utk field diskon
            case Types.INTEGER : return value.equals("")?"0":Integer.valueOf( value.replace(retail.digit_separator,"") ).toString();  //((Integer)value).toString();    //(new Integer(value.toString())).toString();    //Integer.valueOf( (Int)value );
            case Types.BIGINT  : return value.equals("")?"0":Integer.valueOf( value.replace(retail.digit_separator,"") ).toString();  //((Integer)value).toString();    //(new Integer(value.toString())).toString();    //Integer.valueOf( (Int)value );
            case Types.SMALLINT: return value.equals("")?"0":Integer.valueOf( value.replace(retail.digit_separator,"") ).toString();  //((Integer)value).toString();    //(new Integer(value.toString())).toString();    //Integer.valueOf( (Int)value );
            case Types.DOUBLE  : return Double.valueOf(value).toString();  //((Double)value).toString();
            case Types.FLOAT   : return Float.valueOf(value).toString();  //((Float)value).toString();
            case Types.BIT     : return Boolean.valueOf(value).toString();  //((Boolean)value).booleanValue() ? "1" : "0";
            case Types.DATE    : return value; // This will need some conversion.
            default            : return value;
        }
*/
    }
    public String to_db(int col_idx, Object val) {
        //nop, i've used paramaterized val ... if (val == null) return "null";
        if( col_editor[col_idx] instanceof JCdb )    return ((Object)((JCdb)col_editor[col_idx]).my_key_of(val.toString())).toString();    //val = 1 + ((JCdb)col_editor[col_idx]).my_index_of(val.toString());
        else                                         return to_str(col_idx, val);
    }
    public int getIntAt(int row_idx, int col_idx) {
        return Integer.valueOf( getValueAt(row_idx, col_idx).toString() );     //return Integer.valueOf( getValueAt(row_idx, col_idx).toString().replace( retail.digit_separator, "" ).replace("%","") );
    }

    private String where_clause = "";
    private String[] params;
    private String table;
    public void construct_sql_clause( String new_val, int row_idx, int skip_col_idx ) { //construct where_clause and params
        try {
            if( table_name==null ) JOptionPane.showMessageDialog( retail.f, "\nNama Table \"null\"!", "Kesalahan", JOptionPane.ERROR_MESSAGE);// Some of the drivers seem buggy, table should not be null.
            int set_count = new_val==null?0:1 ;
            String id = "";
            String[] params_all = new String[ getColumnCount() + set_count - ( skip_col_idx>=0 ? 1 : 0 ) ];
            params_all[0] = new_val;  //for the SET sql parameter
            where_clause = "";
            for( int c=0; c<getColumnCount(); c++ ) {
                if( c==skip_col_idx ) {
                    set_count -- ;  //agar index params_all tidak lompat...
                    continue;
                }
                if( (columnNames[c]).trim().equals("") ) continue;
                if( !where_clause.equals("") ) where_clause += " AND ";
                params_all[c+set_count] = to_db(c, getValueAt(row_idx, c));
                if( (columnNames[c]).toLowerCase().equals("id") && !params_all[c+set_count].equals("0") ) {  //we found the primary key which was not 0 (was inserted)!!!
                    id = params_all[c+set_count];
                    where_clause = " id = ? ";
                    break;
                }
                where_clause += " " + columnNames[c] + " = ?";    //ada spasi di depan agar replace di if(need_insert) di bawah bekerja dgn tepat .... //if( !id.equals("") ) break;
            }
            //JOptionPane.showMessageDialog( retail.f, "  where_clause= " + where_clause + "\n params_all.length=" + params_all.length + "     params_all[0]=" + params_all[0] +  "   set='" + new_val +  "'   WHERE id=" + id +  "params_all[1]=" + params_all[1], "Kesalahan", JOptionPane.ERROR_MESSAGE);
            params = null;
                 if( id.equals("") ) params = params_all;
            else if( new_val==null ) params = new String[] { id };
            else                     params = new String[] { new_val, id };
        } catch (Exception e) {
            JOptionPane.showMessageDialog( retail.f, "\nPengolahan Database Gagal\nJenis Kesalahan: " + e.getMessage(), "Kesalahan", JOptionPane.ERROR_MESSAGE);
        }
    }

    public void setValueAt(Object val, int row_idx, int col_idx) {
        String value = to_str( col_idx, val );    //JOptionPane.showMessageDialog( retail.f, "in setval value=" + to_str(col_idx,value) + " getvalue= " + getValueAt(row_idx, col_idx), "Kesalahan", JOptionPane.ERROR_MESSAGE);
                                                  //agak lucu kan pake ngecek col_editor[] dulu:D >> hm di edit hak akses modul jadi ga bisa nyimpan krn setvalue mendetect perubahan value ....
        Boolean val_tetap = to_str( col_idx, getValueAt(row_idx, col_idx) ).equals(value);
        //pucing:0 >> Boolean all_are_foreign = col_editor[0] instanceof JComboBox && col_editor[1] instanceof JComboBox;
        if( val_tetap ) return;    //pucing:0 >> if( val_tetap && !all_are_foreign ) return;    //berat saat loop JCdb:p >> if( to_db( col_idx, getValueAt(row_idx, col_idx).toString().trim() ).equals( to_db(col_idx,value) ) ) return;
        if( !table_name.equals("no_db") ) {    //otherwise ... do ur own db executing:)    //JOptionPane.showMessageDialog( retail.f, "INSIDE setcalue to_db( col_idx, getValueAt(row_idx, col_idx)= " + to_db( col_idx, getValueAt(row_idx, col_idx).toString().trim() ) + "   to_db(col_idx, value) = " + to_db(col_idx, value), "Kesalahan", JOptionPane.ERROR_MESSAGE);
            String sql="";
            String id = getValueAt(row_idx, 0).toString();
            Boolean need_insert = id.equals("0") || id.equals("");   //id value sounds like need to insert :)  //tp sebetulnya ini masi bermasalah klo ada unique key2 yg dibiarkan default oleh user .... akibatnya ga akan bisa insert lagi:D
            //pucing:0 >> if( all_are_foreign ) need_insert = val_tetap && col_editor[0].getSelectedIndex()==0 && col_editor[1].getSelectedIndex()==0;    //jika val_tetap masuk sini, berati dia all_are_foreign
            if( need_insert ) {   //pucing:0 >> //edit hak akses modul perlu lakukan insert jika user milih isian default
                construct_sql_clause( to_db(col_idx, val), row_idx, col_idx );
                sql = " INSERT INTO " + table_name
                            + " SET " + columnNames[col_idx] + " = ?,"
                            + where_clause.replace(" AND ", ", ").replace(" id = ", " id = (SELECT id FROM (SELECT IFNULL( MAX(id), 0) + 1 AS id FROM " +table_name+ ") p ) + '" +params[1]+ "' - " );
/*
                        if( val_tetap ) err_msg = "";    //abaikan duplicate error.
            if( affected <= 0 ) err_msg += "\nMaaf, Tidak ada data yang bisa diupdate!\n\n\n\n\n";
            if( e.getMessage().indexOf("Duplicate entry") >= 0) err_msg += "\nMaaf, ada duplikasi data!\nIsian " + e.getMessage().substring( e.getMessage().indexOf("'"), e.getMessage().lastIndexOf("'")+1 ) + " sudah ada.\nMohon perbaiki isian Saudara!\n\n\n\n\n";
*/

                /* executedbatch yg gue bikin harus tanpa param:)
                if( col_editor[0] instanceof JComboBox && col_editor[1] instanceof JComboBox ) {
                    String[] params_insert = params;
                    params = new String[ params_update.length + params_insert.length ];
                    System.arraycopy( params_update, 0, params, 0, params_update.length );
                    System.arraycopy( params_insert, 0, params, params_update.length, params_insert.length );
                    sql = sql.replace("INSERT INTO", " ;\n INSERT IGNORE INTO").replace(" UPDATE ", " UPDATE IGNORE ");    //|| ( col_editor[0] instanceof JComboBox && col_editor[1] instanceof JComboBox && col_editor[0].getSelectedIndex()==0 && col_editor[1].getSelectedIndex()==0 
                }
                */
            } else {
                construct_sql_clause( to_db(col_idx, val), row_idx, -1 );
                sql = " UPDATE " + table_name
                           + " SET " + columnNames[col_idx] + " = ? "
                           + " WHERE " + where_clause
                           + " LIMIT 1";
            }
                //JOptionPane.showMessageDialog( retail.f, sql+ "\nparams[0]=" + params[0]+ "\nparams[1]=" + params[1], "Kesalahan", JOptionPane.ERROR_MESSAGE);
            exec(sql, params, true);
            if( err_msg != "" ) {
                if( err_msg.indexOf("duplikasi data") >= 0 && col_editor[0] instanceof JComboBox && col_editor[1] instanceof JComboBox ) {    //tangani manual, hahahaha
                    String keys = ( col_idx==0 ? value + " - " + to_str( 1, getValueAt(row_idx, 1) ) : to_str( 0, getValueAt(row_idx, 0) ) + " - " + value ) ;
                    err_msg = err_msg.substring( 0, err_msg.indexOf("'")+1 ) + keys + err_msg.substring( err_msg.lastIndexOf("'"), err_msg.length() ) ;
                }
                JOptionPane.showMessageDialog( retail.f, err_msg, "Kesalahan", JOptionPane.ERROR_MESSAGE);
                return;
            }
            if( need_insert && !(col_editor[0] instanceof JComboBox) ) ((ArrayList<Object>)rows.get(row_idx)).set(0,last_inserted_id);   //id value sounds like was just inserted :)
        }    //from  if( !table_name.equals("no_db") ) {    //otherwise ... do ur own db executing:)

        ((ArrayList<Object>)rows.get(row_idx)).set(col_idx,value); 
        fireTableCellUpdated(row_idx, col_idx);   //memang diperlukan :)
    }

    public void removeRow(int row_idx) {
        String id = getValueAt(row_idx, 0).toString();
        if( !id.equals("0") && !id.equals("") && !table_name.equals("no_db") ) { //escape if only need to abort last inserted row or if this table is no_db // || row_idx!=rows.count()-1 
            construct_sql_clause(null, row_idx, -1);
            String sql = " DELETE FROM " +table_name
                       + " WHERE " + where_clause
                       + " LIMIT 1";
            exec(sql, params, true);
            if( err_msg != "" ) {
                JOptionPane.showMessageDialog( retail.f, err_msg, "Kesalahan", JOptionPane.ERROR_MESSAGE);
                return;
            }
        }
        rows.remove(row_idx);
        fireTableRowsDeleted(row_idx, row_idx);    //belum refresh :p
        //fireTableDataChanged();  //ini masi ada sisa row di akhir jika sedang difilter...
        //fireTableChanged(new TableModelEvent(this));

/*
           for(int rowIndex = data.size() - 1; rowIndex >= 0; rowIndex--) {
        if(data.get(rowIndex).isSelect()) {
          data.remove(rowIndex); break;
         }
*/
    }


    public void addRow( int row_idx, Object[] rs_row, int[] type, Boolean fireInserted ) {   //Boolean fireInserted mencegah fireTableRowsInserted saat load pertamakali krn sudah akan difireTableChanged
        //if table.getSelectedRow() < table.getRowCount() -1  return;
        ArrayList<Object> newRow = new ArrayList<Object>();
        for( int i=0; i<getColumnCount(); i++ ) {  //ini jg bisa: metaData.getColumnCount()
	    Object obj = rs_row[i];
	    //int type_  = type[i];
            //what u will see not what u get:)
            if( col_editor[i] != null ) {
                if( col_editor[i] instanceof JComboBox ) {
                    if( obj.toString().equals("") ) {
                        obj = col_editor[0] instanceof JComboBox ? 0 : 1;    //agak lucu kan pake ngecek col_editor[0] dulu:D >> //tapi tetap di hak akses modul itu bisa diisi kosong oleh user << lah, otherwise ... malah ngelock by duplikat error :p >> paksa foreignkey selalu terisi .. unfully checked :) .. hm di edit hak akses modul jadi ga bisa nyimpan krn setvalue mendetect perubahan value ....
                        obj = ((JCdb)col_editor[i]).getItemAt( (Integer)obj - 1 );
                    } else
                        obj = ((JCdb)col_editor[i]).my_jcdb_item_of_key( (Integer)obj );    //kayaknya lambat deh >> obj = ((JCdb)col_editor[i]).my_item_of_key( Integer.valueOf(obj.toString()) );

                    //if( obj.toString().equals("") ) obj = col_editor[0] instanceof JComboBox ? 0 : 1;    //agak lucu kan pake ngecek col_editor[0] dulu:D >> //tapi tetap di hak akses modul itu bisa diisi kosong oleh user << lah, otherwise ... malah ngelock by duplikat error :p >> paksa foreignkey selalu terisi .. unfully checked :) .. hm di edit hak akses modul jadi ga bisa nyimpan krn setvalue mendetect perubahan value ....
                    //obj = ((JCdb)col_editor[i]).getItemAt( (Integer)obj - 1 );

                    //unfully tested >> obj = ((JComboBox)col_editor[i]).getItemAt( (Integer)obj - 1 );
                    if( obj==null ) obj="";    //supaya tetap string .. unfully checked :)
                    if( !table_name.equals("no_db") ) obj = obj.toString();    //tanpa toString(), sortnya error:) tapi utk "no_db" malah toString() bikin error saat open pertamakali:) ... ntah kenapa ... males ngeceknya :p
                }
            } else {    //init value then    //gak jadi .... format to view in table
                    if( obj==null ) obj="";    //supaya tetap string .. unfully checked :)
                //String val = obj.toString();    //obj.toString() perlu!!! utk sorter ....
/*
saat sorting, ....
TableRowSorter uses Comparators for doing comparisons. The following defines how a Comparator is chosen for a column:

If a Comparator has been specified for the column by the setComparator method, use it.
If the column class as returned by getColumnClass is String, use the Comparator returned by Collator.getInstance().
If the column class implements Comparable, use a Comparator that invokes the compareTo method.
If a TableStringConverter has been specified, use it to convert the values to Strings and then use the Comparator returned by Collator.getInstance().
Otherwise use the Comparator returned by Collator.getInstance() on the results from calling toString on the objects.

   Kesimpulannya gini (setelah kutest:p): jika getColumnClass(int column) = Integer.class (ato yg lain selain Object.class),
   dia akan coba sort dengan lakukan value.toString() dulu yg bakal gagal saat fireinsertedrow (dalam kondisi tersorted descending).
   Aku jg ga tau persis knapa gagalnya di situ, yg jelas errornya: gagal casting integer to string (krn isinya 0, bukan string).
   Tapi jika getColumnClass(int column) = Object.class emang ga ada kegagalan tsb. Entahlah, aku jg bingung:D.
   Anyway, yg jelas: Integer.class worthy dan bekerja (buktinya error tsb bisa muncul:p).
   Dan menurut manualnya, Integer.class lebih cepat daripada Object.class saat sorting.
   Maka dari itu, saya ubah yg di bawah ini. (kapan ya selesainya coding aplikasi ini:( Da hampir 4 bulan kali:p)

   Well, ternyata beda behaviournya ... still don't know why, but this is my working solution :p
*/

                //THIS MAGIC CASTING (Object) 0 ... TAKE MY THREE DAYS (INCLUDING INFLUENZA) :P .... and this is at 2.00 AM
                Object zero = table_name.equals("no_db") ? "0" : ( ( type[i]==Types.INTEGER&&!isSigned[i] ) || type[i]==Types.BIGINT ? (Object) 0L : (Object) 0 ) ;
                //Object zero = row_idx==0 ? 0 : getValueAt(0, i);

                switch( type[i] ) {
                    case Types.TINYINT : obj = obj.toString().equals("")?zero:obj;  break;
                    case Types.SMALLINT: obj = obj.toString().equals("")?zero:obj;  break;
                    case Types.INTEGER : obj = obj.toString().equals("")?zero:obj;  break;
                    case Types.BIGINT  : obj = obj.toString().equals("")?zero:obj;  break;
                    case Types.DOUBLE  : obj = obj.toString().equals("")?zero:obj;  break;
                    case Types.FLOAT   : obj = obj.toString().equals("")?zero:obj;  break;
                    case Types.BIT     :   break;
                    case Types.DATE    : obj = obj.toString().equals("")?(Object)0:obj;  break;    //"1900-01-01"
                    case Types.TIMESTAMP: obj = obj.toString().equals("")?(Object)0 : new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format((Timestamp)obj);  break;    //case Types.TIMESTAMP: obj = obj.toString().equals("")?(Object)0 : new java.util.Date(((Timestamp)obj).getTime()).toString();  break;    //ketambahan dua digit di belakang:p
                    //default            :   
                }
                //if( columnNames[i].indexOf("diskon")>=0 ) val += "%";
                //obj = val;
            }
	    newRow.add(obj);
        }
        rows.add(row_idx,newRow);    //rows.addElement(newRow);
            //JOptionPane.showMessageDialog( retail.f, "before fire ... row_idx="+row_idx , "Kesalahan", JOptionPane.ERROR_MESSAGE);
         //((DefaultTableModel)table.getModel()).addRow(new java.util.Vector<String>(java.util.Arrays.asList(new String[]{String.valueOf(x++),"",""})));  
        //if( rs_row.length>0 )
                //try{
        if( fireInserted ) fireTableRowsInserted(row_idx, row_idx);    //jika ini error, cek table.getSelectionModel().addListSelectionListener    //fireTableRowsInserted(getRowCount()-1, getRowCount()-1);
                    //} catch (Exception ex) {    JOptionPane.showMessageDialog( null, "from fire \n. Pesan Kesalahan: " + ex + "  getColumnName=" + getColumnName(5)+ getColumnClass(5).getName() + (type[5]==Types.TINYINT), "Gagal baca Variable", JOptionPane.ERROR_MESSAGE); }
        //fireTableDataChanged();
    }

    public void addRow( Object[] rs_row, int[] type ) {   //overload method, ga perlu fireInserted krn dipanggil oleh show_table
        addRow( getRowCount(), rs_row, type, false );
    }
    public void addRow( int row_idx, Boolean fireInserted ) {   //overload method
        Object[] rs_row = new Object[getColumnCount()];
        for( int i=0; i<rs_row.length; i++ ) rs_row[i] = "";
        addRow( row_idx, rs_row, col_type, fireInserted );
    }
    public void addRow(int row_idx) {   //overload method
        addRow( row_idx, true );
    }    
    public void addRow() {   //overload method, ga perlu fireInserted krn dipanggil oleh show_table
        addRow( getRowCount(), false );
    }    

    public String get_column_pattern(int column) {
        int len = 16;
        try {
            len  = metaData.getPrecision(column+1);    //getColumnDisplaySize
            if( isSigned[column] ) len--;    //Indicates whether values in the designated column are signed numbers.
        } catch (SQLException e) {
            return ".{0," +len+ "}";
        }

        switch( col_type[column] ) {
            //case Types.BIT: return Boolean.class;

        case Types.TINYINT  : //return "\\d{0,2}";   //"\\d{1," >> dia lakukan validasi klo disetText("") atau setText(null) dari code     //(otherwise, overload patternfilter dan cek apa lebih besar dari maksimum number :p) cari aman aja dulu batasin maxnya :p
        case Types.SMALLINT : //return "\\d{0,4}";
        case Types.INTEGER  : //return "\\d{0,9}";
             return   ( columnNames[column].indexOf("stok")==0 || columnNames[column].indexOf("amount")==0 ? "^-?" : "" )
                    //ga jadi, harusnya di on posting setvalue >> krn klo user ngubah ngubah 30 ke 20 tapi dengan cara tekan delete jadi ga bs:p + ( columnNames[column].indexOf("banyak")==0 ? "^[1-9]" : "" )
                    + "\\d{0,"+(len-1)+ "}";   //stok need to allow negative too:p >> //"\\d{1," >> dia lakukan validasi klo disetText("") atau setText(null) dari code     //(otherwise, overload patternfilter dan cek apa lebih besar dari maksimum number :p) cari aman aja dulu batasin maxnya :p

        case Types.BIGINT   : return "^-?\\d{1,19}$";    //utk masang negative sign, ini ada contoh yg agak mirip seh>> Pattern.compile("T(-{0,1}(?!0)\\d+)");  Please note the usage of negative look-ahead (?!0) to exclude -0 number and numbers that start with 0.

        //case Types.FLOAT:
        //case Types.DOUBLE:
            //return Double.class;

        //case Types.DATE: return java.sql.Date.class;

        default: return ( columnNames[column].equals("code") ? "ean13" : "" )    + ".{0," +len+ "}";
        }
    }

/*
    public Boolean getAutoCommit() {
        open();
        try {
            return con.getAutoCommit();
        } catch (SQLException e) {
            JOptionPane.showMessageDialog( retail.f, "Gagal Baca Status AutoCommit. Hubungi Administrator! " + e, "Kesalahan", JOptionPane.ERROR_MESSAGE);
        }
        return false;
    }
    public void setAutoCommit(Boolean auto_commit) {
        open();
        try {
            con.setAutoCommit( auto_commit );
        } catch (SQLException e) {
            JOptionPane.showMessageDialog( retail.f, "Gagal Setting Status AutoCommit. Hubungi Administrator! " + e, "Kesalahan", JOptionPane.ERROR_MESSAGE);
        }
    }
*/

/*
    public void addTableModelListener(new TableModelListener() {
        public void tableChanged(TableModelEvent e) {
            JOptionPane.showMessageDialog( null, "\n: " + e, "Kesalahan", JOptionPane.ERROR_MESSAGE);
        }
    });
*/


}